SystemOrganization addCategory: #'Ma-Core-Abstractions'!
SystemOrganization addCategory: #'Ma-Core-Constants'!
SystemOrganization addCategory: #'Ma-Core-Domain'!
SystemOrganization addCategory: #'Ma-Core-Exceptions'!
SystemOrganization addCategory: #'Ma-Core-Requests'!
SystemOrganization addCategory: #'Ma-Core-Utilities'!
SystemOrganization addCategory: #'Ma-Core-SUnit extensions'!

!Integer methodsFor: '*ma-core' stamp: 'cmm 11/19/2009 20:56'!
billion
	^self*1000000000! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 11/19/2009 20:56'!
hundred
	^self*100! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 3/22/2011 20:33'!
maBitClear: index 
	"Return the receiver with the bit at index cleared."
	^ self
		bitAt: index
		put: 0! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 3/22/2011 20:33'!
maBitSet: index 
	"Return the receiver with the bit at index set."
	^ self
		bitAt: index
		put: 1! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 9/1/2006 17:51'!
maIsBitClear: bitPosition 
	^ (self maIsBitSet: bitPosition) not! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 9/1/2006 17:52'!
maIsBitSet: bitPosition 
	^ self 
		anyBitOfMagnitudeFrom: bitPosition
		to: bitPosition! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 11/19/2009 20:56'!
million
	^self*1000000! !

!Integer methodsFor: '*ma-core' stamp: 'cmm 11/19/2009 20:56'!
thousand
	^self*1000! !

!Stream methodsFor: '*ma-core' stamp: 'cmm 7/9/2008 21:00'!
ensureOpen
	"Base squeak assumes the need for some releasing FileStream compatibility.  However, the initializing compatibility was overlooked.  This provides some."
	^ self! !

!Stream methodsFor: '*ma-core' stamp: 'cmm 7/9/2008 21:00'!
open
	"Base squeak assumes the need for some releasing FileStream compatibility.  However, the initializing compatibility was overlooked.  This provides some."
	^ self! !

!ReadStream methodsFor: '*ma-core' stamp: 'cmm 7/1/2003 22:12'!
maUpToIncluding: anObject

	| start end |
	start := position+1.
	end := collection indexOf: anObject startingAt: start ifAbsent: [ 0 ].

	"not present--return rest of the collection"	
	end = 0 ifTrue: [ ^self upToEnd ].

	"skip to the end and return the data passed over"
	position := end.
	^collection copyFrom: start to: end! !

!WriteStream methodsFor: '*ma-core' stamp: 'cmm 7/30/2007 00:23'!
maPrint: anObject 
	anObject maPrintOn: self! !

!WriteStream methodsFor: '*ma-core' stamp: 'cm 12/24/2001 16:03'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

!MessageTally class methodsFor: '*ma-core' stamp: 'cmm 11/10/2010 13:22'!
maSpyOn: spyBlock if: conditionBlock 
	^ conditionBlock
		ifTrue: [ self spyOn: spyBlock ]
		ifFalse: spyBlock! !

!MessageTally class methodsFor: '*ma-core' stamp: 'cmm 11/10/2010 13:41'!
maSpyOn: aBlock toFileNamed: fileName reportOtherProcesses: aBoolean if: conditionBlock 
	conditionBlock value
		ifTrue:
			[ self
				spyOn: aBlock
				toFileNamed: fileName
				reportOtherProcesses: aBoolean ]
		ifFalse: aBlock! !

Notification subclass: #MaNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

!MaNotification methodsFor: 'as yet unclassified' stamp: 'cmm 10/11/2013 14:05'!
defaultAction
	self resume! !

!MaNotification methodsFor: 'as yet unclassified' stamp: 'cmm 11/28/2011 19:40'!
messageText

	^super messageText ifNil: [ self species name ]! !

!PackageInfo class methodsFor: '*ma-core' stamp: 'cmm 3/8/2011 19:59'!
maPackages
	^ (self allPackages select: 
		[ : each | 
		(each packageName 
			maBeginsWith: 'Ma'
			caseSensitive: true) or: 
			[ {  'WriteBarrier'. 'Collections-BTree'  } anySatisfy: [ : eachAlt | eachAlt = each packageName ] ] ]) collect: [ : each | PackageInfo named: each packageName ]! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 3/20/2009 16:26'!
calculatePrerequisitesUsingMap: map 
	^ map at: self! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 3/18/2009 21:10'!
localRepositories
	^ self repositories select: [ : each | each isDirectoryRepository ]! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 3/21/2009 18:22'!
packageNames
	"My name and the names of the all direct and indirect prerequistes."
	^ self allPrerequisitePackageNames
		add: self packageName ;
		yourself! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 3/17/2009 10:22'!
patchNames
	"Answer a collection of change-set patches required for this package."
	^ #()! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 3/18/2009 21:06'!
repositories
	^ self workingCopy repositoryGroup repositories! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 11/9/2010 22:48'!
resourceNames
	"Answer a collection of files to load after the code has been loaded."
	^ #()! !

!PackageInfo methodsFor: '*ma-core' stamp: 'cmm 9/7/2013 11:13'!
whyNeeded: anotherPackage 
	| answer |
	answer := OrderedCollection new.
	anotherPackage externalUsers do: 
		[ : each | 
		each key packageInfo ifNotNilDo: [ : pi | pi = self ifTrue: [ answer add: each ] ] ].
	anotherPackage externalSubclasses do: 
		[ : each | 
		each packageInfo ifNotNilDo: [ : pi | pi = self ifTrue: [ answer add: each ] ] ].
	^ answer! !

!FileDirectory class methodsFor: '*ma-core' stamp: 'cmm 4/21/2009 22:12'!
maDirectoryEntryFor: fullyQualifiedFilename 
	"Given fullyQualifiedFilename, answer a DirectoryEntryFile if fullyQualifiedFilename is a file, or a DirectoryEntryDirectory if it refers to a directory."
	^ (FileDirectory on: fullyQualifiedFilename) in: [ : fd | fd containingDirectory entryAt: fd localName ]! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 2/20/2009 16:02'!
asFileDirectory
	^ self! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 4/4/2007 09:39'!
assureAbsence
	self exists ifTrue: [ self recursiveDelete ]! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 2/18/2009 15:03'!
directoryName
	"Answer the directory to shell to for this item."
	^self pathName! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 3/23/2007 12:12'!
maCopyFileNamed: sourceFilename toDirectory: aFileDirectory 
	| sourceStream |
	sourceStream := (self readOnlyFileNamed: sourceFilename) binary.
	^ aFileDirectory 
		putFile: sourceStream
		named: (aFileDirectory localNameFor: sourceFilename)! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 3/19/2009 22:10'!
maDetectFile: whereBlock ifFound: foundBlock ifNone: noneBlock 
	^ (self maFindEntries: whereBlock) 
		ifEmpty: noneBlock
		ifNotEmptyDo: [ : results | foundBlock value: results anyOne ]! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 4/8/2002 20:52'!
maEntriesMatching: pat
	"FileDirectory default fileNamesMatching: '*'"

	^ self entries select: [ :each | pat match: each name ]
! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 4/21/2009 13:45'!
maFileNamed: aString do: oneArgBlock 
	"A convenient accessing method for accessing a file without having to open and close yourself.  The oneArgBlock argument is the fileStream."
	| fileStream |
	fileStream := StandardFileStream fileNamed: (self fullNameFor: aString).
	fileStream ifNil: [ MaEnvironmentError signal: 'Could not open ' , aString , ' in use?' ].
	^ [ oneArgBlock value: fileStream ] ensure: [ fileStream close ]! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 12/4/2007 22:44'!
maFindEntries: oneArgBlock 
	"Traverse my directory and answer an OrderedCollection of DirectoryEntry's whose path of DirectoryEntry's causes oneArgBlock to value true."
	| answer |
	answer := OrderedCollection new.
	self directoryTreeDo: [ : path | (oneArgBlock value: path) ifTrue: [ answer add: path last ] ].
	^ answer! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 9/20/2007 17:31'!
maFindEntriesMatching: substring 
	"Traverse my directory and answer an OrderedCollection of DirectoryEntry's whose names contain substring."
	"This method focuses on user-convenience; eschewing complex wild-card matching in favor of 'type-and-go'.  But without punishing engineers who still want to use wild-card matching."
	| usePatternMatch |
	usePatternMatch := substring includesAnyOf: #($* $# ).
	^ self maFindEntries: 
		[ : path | 
		path last name in: 
			[ : theName | 
			usePatternMatch 
				ifTrue: [ substring match: theName ]
				ifFalse: 
					[ theName 
						includesSubstring: substring
						caseSensitive: false ] ] ]! !

!FileDirectory methodsFor: '*ma-core' stamp: 'cmm 4/18/2010 23:04'!
maNameFor: filename relativeTo: containingDirectory 
	"Assume that I am contained somewhere in the tree of containingDirectory.  Answer the semi-qualified name for filename, qualified from containingDirectory down to this location."
	| fullName |
	fullName := self fullNameFor: filename.
	^ fullName 
		copyFrom: containingDirectory pathName size + 2
		to: fullName size! !

!Dictionary methodsFor: '*ma-core' stamp: ''!
maAllKeysAtValue: anObject

	| aCollection |

	aCollection := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | value = anObject ifTrue: [ aCollection add: key ] ].
	^aCollection! !

!Dictionary methodsFor: '*ma-core' stamp: 'cmm 10/27/2010 20:49'!
maBindingAtRandom
	| binding | binding := nil.
	[ binding isNil ] whileTrue: [ binding := array at: (1 to: array size) atRandom ].
	^ binding! !

!Dictionary methodsFor: '*ma-core' stamp: 'cmm 10/27/2010 20:50'!
maKeyAtRandom
	^ self maBindingAtRandom key! !

!Dictionary methodsFor: '*ma-core' stamp: 'cmm 7/24/2002 20:45'!
maShallowCopy

	| copy |
	copy := self species new.  "new: seems buggy w/ Dictionaries.."
	self keysAndValuesDo: 
		[ :eachKey :eachValue | copy at: eachKey put: eachValue ].
	^copy! !

!OrderedCollection methodsFor: '*ma-core' stamp: 'cm 1/7/2002 16:25'!
maAddAll: aSequenceableCollection afterIndex: integerIndex

	aSequenceableCollection reverseDo: [:each | self add: each afterIndex: integerIndex ].
	^aSequenceableCollection
! !

!OrderedCollection methodsFor: '*ma-core' stamp: 'cmm 1/9/2013 20:27'!
removeAllNoGarbage
	1 to: array size do: [ : n | array at: n put: nil ].
	self reset! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 10/28/2011 15:53'!
at: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock 
	| current uniqueObj |
	uniqueObj := String empty.
	^ (current := self 
		at: anObject
		ifAbsent: [ uniqueObj ]) == uniqueObj 
		ifTrue: [ zeroArgBlock value ]
		ifFalse: [ oneArgBlock value: current ]! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 1/18/2012 16:01'!
coordinatesDo: twoArgBlock 
	"Value twoArgBlock with each x and y of my coordinates."
	self do:
		[ : eachPoint | twoArgBlock
			value: eachPoint x
			value: eachPoint y ]! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 1/27/2013 13:22'!
iPointjPointDo: fourArgBlock 
	"Assuming I contain points of a 
	Enumerate the ring, valuing fourArgBlock with iPointX, iPointY, jPointX and jPointY.  First-class Points are avoided because these algorithms must run at the maximum possible speed."
	| iPointX iPointY firstPointX firstPointY |
	iPointX := iPointY := firstPointX := firstPointY := nil.
	self coordinatesDo:
		[ : jPointX : jPointY | 
		iPointX 
			ifNil: 
				[ firstPointX := jPointX.
				firstPointY := jPointY ]
			ifNotNil: 
				[ fourArgBlock 
					value: iPointX
					value: iPointY
					value: jPointX
					value: jPointY ].
		iPointX := jPointX.
		iPointY := jPointY ].
	fourArgBlock 
		value: iPointX
		value: iPointY
		value: firstPointX
		value: firstPointY! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 5/18/2004 12:01'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection and in the same order."

	self == anotherCollection ifTrue: [ ^ true ].
	self size = anotherCollection size ifFalse: [ ^false ].
	self
		with: anotherCollection
		do: [ :eachInSelf :eachInOther | eachInSelf = eachInOther ifFalse: [ ^false ] ].
	^true
! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 1/20/2010 09:24'!
maPermutations
	^ Array streamContents: 
		[ : stream | 
		self maPermutationsDo: [ : eachCombo | stream nextPut: eachCombo copy ] ]! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 1/16/2010 18:49'!
maPermutationsDo: aBlock 
	"I am a collection of other SequenceableCollections.  For each combination of elements in my element-Collections, value aBlock with the arguments Array of each combination of elements."
	| numberOfCombinations args valueAtBlock permutationsSpec |
	permutationsSpec := self select: [ : each | each notEmpty ].
	permutationsSpec ifEmpty: [ ^ self ].
	numberOfCombinations := permutationsSpec 
		inject: 1
		into: [ : prod : each | each size * prod ].
	args := Array new: permutationsSpec size.
	"Eliminate empty Array specifications, rather than complicate enumeration logic, below."
	valueAtBlock := 
	[ : elementIndex | 
	1 
		to: permutationsSpec size
		do: 
			[ : innerIndex | 
			| eachInnerArray radix |
			eachInnerArray := permutationsSpec at: innerIndex.
			radix := 1.
			1 
				to: innerIndex - 1
				do: [ : eachOrder | radix := radix * (permutationsSpec at: eachOrder) size ].
			args 
				at: innerIndex
				put: (eachInnerArray at: elementIndex // radix \\ eachInnerArray size + 1) ].
	aBlock value: args ].
	"With this formula, the last is the first, the first is the second."
	valueAtBlock value: numberOfCombinations.
	1 
		to: numberOfCombinations - 1
		do: valueAtBlock! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 10/7/2010 20:26'!
maPermutationsDo: aBlock separatedBy: separatorBlock 
	"I am a collection of other SequenceableCollections.  For each combination of elements in my element-Collections, value aBlock with the arguments Array of each combination of elements, and evaluate the separatorBlock between."
	| beforeFirst |
	beforeFirst := true.
	self maPermutationsDo:
		[ : each | beforeFirst
			ifTrue: [ beforeFirst := false ]
			ifFalse: [ separatorBlock value ].
		aBlock value: each ]! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 11/2/2010 15:09'!
maPermutationsSize
	"Assume I am an Array of Array's that will be permuted via maPermuationsDo:.  Progress-indication is useful in this situation."
	^ self
		inject: 1
		into:
			[ : prod : each | prod * (each size max: 1) ]! !

!SequenceableCollection methodsFor: '*ma-core' stamp: 'cmm 7/24/2011 16:46'!
maPermutationsWithIndexesDo: aBlock 
	"I am a collection of other SequenceableCollections.  For each combination of elements in my element-Collections, value aBlock with the arguments Array of each combination of elements."
	| numberOfCombinations args valueAtBlock permutationsSpec indexes |
	"Eliminate empty Array specifications, rather than complicate enumeration logic."
	permutationsSpec := self select: [ : each | each notEmpty ].
	permutationsSpec ifEmpty: [ ^ self ].
	numberOfCombinations := permutationsSpec maPermutationsSize.
	args := Array new: permutationsSpec size.
	indexes := Array new: permutationsSpec size.
	valueAtBlock := 
	[ : elementIndex | 
	1 
		to: permutationsSpec size
		do: 
			[ : innerIndex | | eachInnerArray innerArrayIndex radix |
			eachInnerArray := permutationsSpec at: innerIndex.
			radix := 1.
			1 
				to: innerIndex - 1
				do: [ : eachOrder | radix := radix * (permutationsSpec at: eachOrder) size ].
			innerArrayIndex := elementIndex // radix \\ eachInnerArray size + 1.
			indexes at: innerIndex put: innerArrayIndex.
			args 
				at: innerIndex
				put: (eachInnerArray at: innerArrayIndex) ].
	aBlock value: args value: indexes ].
	"With this formula, the last is the first, the first is the second."
	valueAtBlock value: numberOfCombinations.
	1 
		to: numberOfCombinations - 1
		do: valueAtBlock! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 1/2/2013 15:04'!
changesEntry
	^ FileDirectory default entryAt: (FileDirectory localNameFor: Smalltalk changesName)! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 3/24/2013 16:11'!
defaultMaxMemory
	"Images can be up to 1GB (512MB on Windows) when the -memory parameter is not specified."
	^ Smalltalk platformName = 'Win32'
		ifTrue: [ 500000000 ]
		ifFalse: [ 1000000000 ]! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 1/2/2013 15:04'!
imageEntry
	^ FileDirectory default entryAt: (FileDirectory localNameFor: Smalltalk imageName)! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 10/10/2010 21:30'!
maAuthorInitials
	^ (Smalltalk hasClassNamed: #Utilities)
		ifTrue:
			[ | init |
			init := (Smalltalk classNamed: #Utilities) authorInitialsPerSe.
			init isEmptyOrNil
				ifTrue: [ 'unknown' ]
				ifFalse: [ init ] ]
		ifFalse: [ 'unknown' ]! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 9/23/2008 14:59'!
maIsLowOnMemory
	"Answer whether the VM is within ten-million bytes of available memory.  The goal is to avoid the LowSpace warning."
	^ self maMemoryAvailable < 10000000! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 10/12/2013 18:20'!
maMaxMemory
	"If the special argument to the vm, -memory, was provided, use number following it.  Else 450MB."
	| foundMemoryArg |
	foundMemoryArg := false.
	self optionsDo: 
		[ : each | 
		(#('-memory' '-mmap') includes: each)
			ifTrue: [ foundMemoryArg := true ]
			ifFalse: 
				[ foundMemoryArg ifTrue: 
					[ | arg |
					arg := each.
					(arg isEmptyOrNil or: [ arg size < 2 ]) ifFalse: 
						[ | requestedMemory |
						requestedMemory := (arg 
							copyFrom: 1
							to: arg size - 1) asNumber.
						requestedMemory > 0 ifTrue: 
							[ arg last = $k 
								ifTrue: [ ^ 1000 * requestedMemory ]
								ifFalse: [ arg last = $m ifTrue: [ ^ 1000000 * requestedMemory ] ] ] ] ] ] ].
	^ self defaultMaxMemory! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 9/23/2008 15:06'!
maMemoryAvailable
	"Answer the remaining memory available accessible by this image."
	^ self maMaxMemory - self maMemoryUsed! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 3/1/2013 15:05'!
maMemoryUsed
	^ self vmParameterAt: 3! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 4/11/2010 18:09'!
maSaveAs: newName 
	"Save the image  under that new name."
	newName ifNil: [ ^ self ].
	(SourceFiles at: 2) ifNotNil: 
		[ self
			closeSourceFiles ;
			saveChangesInFileNamed: (self fullNameForChangesNamed: newName)	"so copying the changes file will always work" ].
	self saveImageInFileNamed: (self fullNameForImageNamed: newName)! !

!SmalltalkImage methodsFor: '*ma-core' stamp: 'cmm 3/25/2013 20:24'!
shortImageName
	"The name of this image, sans path and extension."
	^ self imageEntry name copyUpToLast: $.! !

!LargePositiveInteger methodsFor: '*ma-core' stamp: 'cmm 6/13/2010 23:03'!
maLog: anInteger 
	"Answer the log base aNumber of the receiver."
	^ (self log: anInteger) in:
		[ : firstAttempt | firstAttempt = Float infinity
			ifTrue:
				[ | m |
				"Search for it."
				m := 1023.
				(anInteger raisedTo: m) > self
					ifTrue:
						[ [ (anInteger raisedTo: m) < self ] whileFalse: [ m := m - 1 ].
						(m - 1) asFloat ]
					ifFalse:
						[ [ (anInteger raisedTo: m) > self ] whileFalse: [ m := m + 1 ].
						(m - 1) asFloat ] ]
			ifFalse: [ firstAttempt ] ]! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/3/2008 10:40'!
maActualMethod

	| class |
	^(class := self actualClass)
		ifNil: [ nil ]
		ifNotNil:
			[ (class canUnderstand: self selector)
				ifTrue: [ class >> self selector ]
				ifFalse: [ nil ] ]! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/4/2008 19:38'!
maAuthor
	"Answer the author initials of the current version of this method."
	^ self maActualMethod ifNotNilDo: 
		[ : cm | 
		cm timeStamp subStrings ifNotEmptyDo: [ : strings | strings first ] ]! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/3/2008 00:00'!
maClassHierarchy
	^ self actualClass withAllSuperclasses reversed! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/3/2008 19:07'!
maImplementors
	"Answer a collection of MethodReferences with the same selector as myself."
	^ self systemNavigation allImplementorsOf: self selector! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/3/2008 19:09'!
maMethodHierarchy
	"Answer an OrderedCollection of methods in my class-hierarchy with the same selector as mine."
	| superclasses answer |
	answer := OrderedCollection new.
	superclasses := self actualClass allSuperclasses reverse.
	superclasses do: 
		[ : each | 
		(each includesSelector: self selector) ifTrue: [ answer add: (each >> self selector) methodReference ] ].
	self actualClass 
		allSubclassesWithLevelDo: 
			[ : eachClass : level | 
			(eachClass includesSelector: self selector) ifTrue: [ answer add: (eachClass >> self selector) methodReference ] ]
		startingLevel: 0.
	^ answer! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/3/2008 17:46'!
maSenders
	"Answer a collection of MethodReferences that send my selector."
	^ self systemNavigation allCallsOn: self selector! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/3/2008 17:46'!
maSentMessages
	"Answer a Collection of MethodReferences possibly called by this method."
	^ self maSentSelectors 
		inject: OrderedCollection new
		into: 
			[ : oc : each | 
			oc
				addAll: (self systemNavigation allImplementorsOf: each) ;
				yourself ]! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/2/2008 23:38'!
maSentSelectors
	^ self maActualMethod 
		ifNil: 
			[ #() ]
		ifNotNilDo: [ : cm | cm messages ]! !

!MethodReference methodsFor: '*ma-core' stamp: 'cmm 12/4/2008 19:37'!
maTimeStamp
	"Answer the author initials of the current version of this method."
	^ self maActualMethod ifNotNilDo: 
		[ : cm | 
		cm timeStamp subStrings ifNotEmptyDo: 
			[ : strings | 
			DateAndTime 
				date: strings second asDate
				time: strings third asTime ] ]! !

!Class methodsFor: '*ma-core' stamp: 'cmm 6/14/2012 15:58'!
theNonWriteBarrierClass
	^ self! !

!Bag methodsFor: '*ma-core' stamp: 'cmm 12/19/2002 21:33'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Bag methodsFor: '*ma-core' stamp: 'cmm 11/12/2007 00:01'!
printOn: aStream 
	aStream nextPutAll: 
		(self class name first isVowel 
			ifTrue: [ 'an ' ]
			ifFalse: [ 'a ' ]).
	self species printOn: aStream.
	contents keysAndValuesDo: 
		[ : eachKey : eachValue | 
		aStream
			cr ;
			tab ;
			maPrint: eachValue ;
			space ;
			nextPutAll: 'occurrencesOf: ' ;
			maPrint: eachKey ]! !

!SecureHashAlgorithm methodsFor: '*ma-core' stamp: 'cmm 6/9/2005 11:55'!
maHashMessage: aStringOrByteArray from: startPos to: stopPos
	"Hash the given message using the Secure Hash Algorithm."

	^ self
		maHashStream: 
			((ReadStream on: aStringOrByteArray asByteArray)
				position: startPos-1 ;
				yourself)
		to: stopPos! !

!SecureHashAlgorithm methodsFor: '*ma-core' stamp: 'cmm 2/24/2013 16:30'!
maHashStream: aPositionableStream to: endPosition
	"Hash the contents of the given stream from the current position to endPosition using the Secure Hash Algorithm. The SHA algorithm is defined in FIPS PUB 180-1. It is also described on p. 442 of 'Applied Cryptography: Protocols, Algorithms, and Source Code in C' by Bruce Scheier, Wiley, 1996."
	"SecureHashAlgorithm new hashStream: (ReadStream on: 'foo')"

	| startPosition buf bitLength |
	self initializeTotals.

	"(SecureHashAlgorithm new hashMessage: '') radix: 16 	
	=> 'DA39A3EE5E6B4B0D3255BFEF95601890AFD80709'"
	aPositionableStream position >= endPosition ifTrue: [self processFinalBuffer: #() bitLength: 0].

	startPosition := aPositionableStream position.
	[aPositionableStream position >= endPosition] whileFalse: [
		buf := aPositionableStream next: (64 min: (endPosition-aPositionableStream position)).
		((aPositionableStream position >= endPosition) not and: [buf size = 64])
			ifTrue: [self processBuffer: buf]
			ifFalse: [
				bitLength := ((aPositionableStream position min: endPosition) - startPosition) * 8.
				self processFinalBuffer: buf bitLength: bitLength]].

	^ self finalHash
! !

!Month methodsFor: '*ma-core' stamp: 'cmm 8/3/2010 23:04'!
maPrintAbbreviatedOn: aStream 
	aStream
		 maPrint: self year asString ;
		 maPrint: $- ;
		 maPrint:
			(self monthIndex
				printPaddedWith: $0
				to: 2)! !

!Month methodsFor: '*ma-core' stamp: 'cmm 8/3/2010 23:33'!
maSuggestedFilename
	"Often, it is useful for month filenames to be sortable, therefore override the standard maSuggestedFilename which would otherwise answer, 'July', 'August', etc."
	^ String streamContents: [ : stream | self maPrintAbbreviatedOn: stream ]! !

!String methodsFor: '*ma-core' stamp: 'cmm 8/4/2013 20:09'!
asUserMessage
	^ MaUserMessage new
		 append: self ;
		 yourself! !

!String methodsFor: '*ma-core' stamp: 'cmm 7/6/2006 12:11'!
between: minString and: maxString
	^ self >= minString  and: [self <= maxString ]! !

!String methodsFor: '*ma-core' stamp: ''!
maAsIntegerFromRadix: anInteger
	"Answer a Smalltalk Integer with an equivalent value of the receiver
	represented in radix anInteger."

	^self
		inject: 0
		into: [ :sum :character | (sum * anInteger) + character digitValue ]
! !

!String methodsFor: '*ma-core' stamp: 'cmm 8/6/2008 21:19'!
maAsNumber
	"Squeak..  Depending on *how* the receiver is not numeric, It sometimes answers 0, other times signals an error."
	| n |
	^ 
	[ n := self asNumber.
	n = 0 ifFalse: [ n ] ] 
		on: Error
		do: [ : err | err return: nil ]! !

!String methodsFor: '*ma-core' stamp: 'cmm 2/27/2008 23:50'!
maBeginsWith: aString caseSensitive: aBoolean 
	"Returns true if the receiver begins with the elements in aString, while ignoring the case if aBoolean is true."
	self size < aString size ifTrue: [ ^ false ].
	"Optimization.  Most strings will differ on the first character.."
	self first asLowercase = aString first asLowercase ifFalse: [ ^ false ].
	^ (self 
		findSubstring: aString
		in: self
		startingAt: 1
		matchTable: (aBoolean 
				ifTrue: [ CaseSensitiveOrder ]
				ifFalse: [ CaseInsensitiveOrder ])) = 1! !

!String methodsFor: '*ma-core' stamp: 'cmm 2/28/2008 00:14'!
maEndsWith: aString caseSensitive: aBoolean 
	"Returns true if the receiver begins with the elements in aString,while ignoring the case if aBoolean is true."
	| extra |
	(extra := self size - aString size) < 0 ifTrue: [ ^ false ].
	^ (self 
		findSubstring: aString
		in: self
		startingAt: extra + 1
		matchTable: (aBoolean 
				ifTrue: [ CaseSensitiveOrder ]
				ifFalse: [ CaseInsensitiveOrder ])) > 0! !

!String methodsFor: '*ma-core' stamp: 'cmm 2/7/2008 17:04'!
maFormattedForPlural: aNumber 
	"This is kind of a wing-nut method, but it can save you some
	redundant code if you care to make your programs user message
	plural and singular friendly.  It will add or remove an s based on
	aNumber and whether or not the receiver already ends in s."
	^ aNumber > 0 & (aNumber <= 1) 
		ifTrue: 
			[ "should not end in s"
			(self 
				maEndsWith: 's'
				caseSensitive: true) 
				ifTrue: 
					[ self 
						copyFrom: 1
						to: self size - 1 ]
				ifFalse: [ self ] ]
		ifFalse: 
			[ (self 
				maEndsWith: 's'
				caseSensitive: true) 
				ifTrue: 
					[ "should end in s"
					self ]
				ifFalse: [ self , 's' ] ]! !

!String methodsFor: '*ma-core' stamp: 'cmm 7/30/2007 00:18'!
maPrintAbbreviatedOn: aStream 
	aStream nextPutAll: self! !

!String methodsFor: '*ma-core' stamp: 'cmm 7/30/2007 00:22'!
maPrintOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*ma-core' stamp: 'cmm 2/2/2008 16:55'!
occurrence: anInteger where: oneArgBlock 
	^ self 
		occurrence: anInteger
		where: oneArgBlock
		startingAt: 1! !

!String methodsFor: '*ma-core' stamp: 'cmm 2/2/2008 17:04'!
occurrence: anInteger where: oneArgBlock startingAt: startPos 
	"Answer the position of the anInteger'th Character, aCharacter, in the receiver.  If not found, answer 0."
	| pos count |
	count := 0.
	pos := startPos.
	[ pos < self size and: [ count < anInteger ] ] whileTrue: 
		[ (oneArgBlock value: (self at: pos)) ifTrue: [ count := count + 1 ].
		pos := pos + 1 ].
	^ count = anInteger 
		ifTrue: [ pos-1 ]
		ifFalse: [ 0 ]! !

!String methodsFor: '*ma-core' stamp: 'cmm 11/5/2007 01:00'!
smalltalkToWords
	"smalltalkString may be a Smalltalk class name, method name, or a parameter name (aString or smalltalkString).
	
	'MauiUserStrategy' answers 'Maui User Strategy'
	'smalltalkToWords:' answers 'Smalltalk To Words:'
	'aString' answers 'A String'
	'aMaObjectSerializer' answers 'A Ma Object Serializer'
	'aMagmaSession' answers 'A Magma Session'
	'A typical overridden name:' answers 'A typical overridden name:'"
	| smalltalkStream words |
	smalltalkStream := self readStream.
	words := String streamContents: 
		[ : stream | 
		[ smalltalkStream atEnd ] whileFalse: 
			[ (smalltalkStream peek isUppercase and: [ stream isEmpty not and: [ stream last ~= Character space ] ]) ifTrue: [ stream space ].
			stream isEmpty 
				ifTrue: [ stream nextPut: smalltalkStream next asUppercase ]
				ifFalse: [ stream nextPut: smalltalkStream next ] ] ].
	^ words! !

!String methodsFor: '*ma-core' stamp: 'cmm 11/5/2013 10:57'!
veryDeepCopy
	"Overridden for performance.  I can't imagine ever wanting to add dependents to a String."
	^ self! !

!DirectoryEntry methodsFor: '*ma-core' stamp: 'cmm 2/12/2009 18:56'!
directoryName
	"Answer the directory to shell to for this item."
	self subclassResponsibility ! !

!DirectoryEntry methodsFor: '*ma-core' stamp: 'cmm 11/27/2011 23:09'!
maFileSizeString
	"Answer my file size as an easy-to-read String."
	^ self fileSize asBytesDescription! !

!DirectoryEntry methodsFor: '*ma-core' stamp: 'cmm 11/27/2011 23:10'!
maTotalFileSizeString
	"Answer my file size as an easy-to-read String."
	^ self totalFileSize asBytesDescription! !

!ZipArchive methodsFor: '*ma-core' stamp: 'cmm 10/30/2009 16:36'!
filesDo: aBlock tempDir: aFileDirectory 
	"Value aBlock with each DirectoryEntryFile in the receiver, after extracting it to aFileDirectory.  aFileDirectory is deleted after all members are valued."
	[ self extractAllTo: aFileDirectory ] ensure: [ self close ].
	
	[ self members do: [ : each | aBlock value: (aFileDirectory entryAt: each localFileName) ] ] ensure: 
		[ self members do: [ : each | aFileDirectory deleteFileNamed: each localFileName ] ]! !

!Error methodsFor: '*ma-core' stamp: 'cmm 7/4/2013 22:43'!
printDetailsOn: aStream 
	| sender |
	sender := self signalerContext sender receiver.
	((sender respondsTo: #magmaOid) and: [ sender isSymbol not ]) ifTrue:
		[ aStream
			 nextPutAll: 'magmaOid:  ' , sender magmaOid asString ;
			 cr ]! !

Error subclass: #MaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

!MaError commentStamp: '<historical>' prior: 0!
Base abstraction for errors that occur in Ma code.!

MaError subclass: #MaCorruptionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

MaError subclass: #MaEnvironmentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

MaError subclass: #MaSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

!MaSoftwareError commentStamp: 'cmm 5/4/2005 10:25' prior: 0!
A software error is a bug in the software.  Signal them when you have to code for something that "should never happen."  For example, if, based on your program logic, there should be an entry in a Dictionary, but it is not there, you would signal a software error.!

MaError subclass: #MaUserError
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

!MaUserError commentStamp: '<historical>' prior: 0!
I represent an error made by the user.!

!MaUserError class methodsFor: 'instance creation' stamp: 'cmm 2/6/2008 16:22'!
page: aMauiPage 
	^ self new
		page: aMauiPage ;
		yourself! !

!MaUserError class methodsFor: 'instance creation' stamp: 'cmm 2/6/2008 16:22'!
signalPage: aMauiPage 
	(self page: aMauiPage) signal! !

!MaUserError methodsFor: 'testing' stamp: 'cmm 9/28/2008 18:18'!
isMaUserError

	^true! !

!MaUserError methodsFor: 'accessing' stamp: 'cmm 2/6/2008 16:21'!
page
	^ page ifNil: [ MauiPage text: self messageText ]! !

!MaUserError methodsFor: 'accessing' stamp: 'cmm 7/12/2010 23:36'!
page: aMauiPage 
	page := aMauiPage.
	self messageText: aMauiPage string! !

!Set methodsFor: '*ma-core' stamp: 'cmm 7/24/2002 20:41'!
maShallowCopy

	| copy |
	copy := self species new: self size.
	self do: [ :each | copy add: each ].
	^copy! !

!Mutex methodsFor: '*ma-core' stamp: 'cmm 7/5/2012 10:12'!
isCritical
	"Answer whether I am guarding execution of a piece of code at the moment."
self maMarked: 'delete'.
	^ semaphore isSignaled not! !

!Character methodsFor: '*ma-core' stamp: 'cmm 7/30/2007 00:22'!
maPrintOn: aStream
	aStream nextPut: self! !

!Character methodsFor: '*ma-core' stamp: 'cmm 7/24/2002 20:44'!
maShallowCopy
	"Characters are unique."

	^self
! !

TestCase subclass: #MaTestCase
	instanceVariableNames: 'suite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-SUnit extensions'!

!MaTestCase commentStamp: '<historical>' prior: 0!
Getting ready to try using "fixtureSpecs" so we can test against hundreds of fixtures easily.
!

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 1/3/2013 14:27'!
buildSuite
	| suite |
	suite := super buildSuite.
	suite tests do: [ : each | each suite: suite ].
	^ suite! !

!MaTestCase class methodsFor: 'testing' stamp: 'cmm 4/18/2002 00:11'!
shouldInheritSelectors

	^false! !

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 4/8/2005 13:05'!
tearDownSuite
	"Counterpart to setUpSuite.  See that method for
	more info."

	Transcript cr; show: 'Tests complete.  Tearing down suite..'! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 5/13/2010 18:53'!
defaultTimeout 
	^ 500 days asSeconds! !

!MaTestCase methodsFor: 'file management' stamp: 'cmm 12/5/2002 23:11'!
deleteFilesNamed: aCollection

	aCollection do:
		[ :each |
		StandardFileStream allInstances do:
			[ :eachStream |
			eachStream fullName = each ifTrue:
				[ self notify: 'closing a rogue FileStream for ', eachStream fullName.
				eachStream close ] ].
		self notify: 'deleting file ', each.
		(FileDirectory forFileName: each) deleteFileNamed: each ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 9/11/2008 19:44'!
environmentDirectory

	^ FileDirectory default! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 1/5/2013 10:10'!
notify: aString 
	MaTestCaseNotification signal: DateAndTime now printString , ':  ' , aString! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 8/19/2007 22:08'!
performTest
	[ self
		notify: 'running ' , self selector , '.. ' ;
		notify: 'time to run ' , self selector , ':  ' , [ super performTest ] durationToRun printString ] 
		on: MaNotification
		do: 
			[ : n | 
			Transcript
				cr ;
				show: n messageText.
			n resume ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 1/3/2013 14:24'!
suite
	^ suite! !

!MaTestCase methodsFor: 'initialize-release' stamp: 'cmm 1/3/2013 14:24'!
suite: aTestSuite
	suite := aTestSuite! !

!Point methodsFor: '*ma-core' stamp: 'cmm 4/9/2010 12:53'!
maCloseTo: aPoint 
	^ (x closeTo: aPoint x) and: [ y closeTo: aPoint y ]! !

!Point methodsFor: '*ma-core' stamp: 'cmm 6/29/2010 22:46'!
maHasZero
	^ x isZero or: [ y isZero ]! !

!Point methodsFor: '*ma-core' stamp: 'cmm 8/31/2010 13:34'!
maLongestSide
	^ x max: y! !

!Delay methodsFor: '*ma-core' stamp: 'cmm 9/1/2004 22:25'!
maReset
	"If I am already waiting, start my wait back at the beginning.  If I'm not yet waiting, no effect."
	resumptionTime := Time millisecondClockValue + delayDuration! !

!UndefinedObject methodsFor: '*ma-core' stamp: 'cmm 10/31/2009 12:31'!
hand
	^ ActiveHand! !

!UndefinedObject methodsFor: '*ma-core' stamp: 'cmm 5/23/2012 21:37'!
hash
	"Squeak's hash for nil since 2009.  Allow this literal to have its own value hash independent of its identityHash, to be safer with distributed systems which may be using nil in a hash calculation."
	^ 1006632960! !

!True methodsFor: '*ma-core' stamp: 'cmm 5/23/2012 20:34'!
hash
	"A value hash for true, so that it can be distinct from its #identityHash (which changed in 2009, causing its hash to change too)."
	^ 773324800! !

!ByteString methodsFor: '*ma-core' stamp: 'cmm 11/10/2005 20:48'!
maAlphabeticalNext
	"Answer the next higher String.  This is useful in indexing systems to search for left-side matching strings."
	| nextValue stream |
	nextValue := (self asByteArray inject: 0 into: [ :sum :each | sum * 256 + each ]) + 1.
	stream := WriteStream on: ByteArray new.
	nextValue digitLength to: 1 by: -1 do:
		[ : digitIndex |
		stream nextPut: (nextValue digitAt: digitIndex) ].
	^ stream contents asString! !

!SolidFillStyle methodsFor: '*ma-core' stamp: 'cmm 12/8/2008 13:38'!
addFillStyleMenuItems: aMenu hand: aHand from: aMorph 
	"Add the items for changing the current fill style of the receiver"
	aMenu 
		add: 'change color...' translated
		target: self
		selector: #changeColorIn:event:
		argument: aMorph! !

!SolidFillStyle methodsFor: '*ma-core' stamp: 'cmm 12/8/2008 13:41'!
changeColorIn: aMorph event: evt
	"Note: This is just a workaround to make sure we don't use the old color inst var"
	aMorph changeColorTarget: aMorph selector: #fillStyle: originalColor: self hand: evt hand! !

!False methodsFor: '*ma-core' stamp: 'cmm 5/23/2012 20:34'!
hash
	"A value hash for false, so that it can be distinct from its #identityHash (which changed in 2009, causing its #hash to change too)."
	^ 826277888! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:24'!
addToDirectoryCount: anInteger 
	self directoryCountStat addValue: anInteger! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:24'!
addToFileCount: anInteger 
	self fileCountStat addValue: anInteger! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:19'!
addToTotalSize: anInteger 
	self fileSizeStat addValue: anInteger! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:54'!
contributeStatisticsTo: aDirectoryEntryDirectory 
	"Add my size information to the cumulative total in aDirectoryEntryDirectory."
	self initializeStatistics.
	aDirectoryEntryDirectory
		addToTotalSize: self totalFileSize ;
		addToDirectoryCount: self directoryCount ;
		addToFileCount: self fileCount! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 9/19/2007 15:41'!
directoryCount
	"Answer the total number of directory entries in my directory, including all subdirectories."
	^ self directoryCountStat sum! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 9/28/2007 12:33'!
directoryCountStat
	"Statistics about the number of directories per folder."
	^ self 
		attributeNamed: #directoryCountStat
		ifAbsent: 
			[ self
				initializeStatistics ;
				directoryCountStat ]! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:22'!
directoryCountStat: aMaStat 
	self 
		attributeNamed: #directoryCountStat
		put: aMaStat! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 2/12/2009 18:56'!
directoryName
	"Answer the directory to shell to for this item."
	^ self asFileDirectory pathName! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 9/19/2007 15:41'!
fileCount
	"Answer the total number of file entries in my directory, including all subdirectories."
	^ self fileCountStat sum! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 9/28/2007 12:32'!
fileCountStat
	"Statistics about the number of files per folder."
	^ self 
		attributeNamed: #fileCountStat
		ifAbsent: 
			[ self
				initializeStatistics ;
				fileCountStat ]! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:21'!
fileCountStat: aMaStat 
	self 
		attributeNamed: #fileCountStat
		put: aMaStat! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 9/13/2007 17:19'!
fileSizeStat
	^ self 
		attributeNamed: #fileSizeStat
		ifAbsent: 
			[ self
				initializeStatistics ;
				fileSizeStat ]! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:19'!
fileSizeStat: aMaStat 
	self 
		attributeNamed: #fileSizeStat
		put: aMaStat! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:48'!
incrementDirectoryOrFileCount: twoElementArray 
	twoElementArray 
		at: 1
		put: (twoElementArray at: 1) + 1! !

!DirectoryEntryDirectory methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:51'!
initializeStatistics
	"Enumerate my entire directory tree to gather my statistics."
	| directoryAndFileCount |
	self
		fileSizeStat: MaStat new ;
		fileCountStat: MaStat new ;
		directoryCountStat: MaStat new.
	directoryAndFileCount := {  0. 0  }.
	self asFileDirectory entries in: 
		[ : myEntries | 
		myEntries
			do: [ : eachEntry | eachEntry contributeStatisticsTo: self ] ;
			do: [ : eachEntry | eachEntry incrementDirectoryOrFileCount: directoryAndFileCount ] ].
	self
		addToDirectoryCount: (directoryAndFileCount at: 1) ;
		addToFileCount: (directoryAndFileCount at: 2)! !

!DirectoryEntryDirectory methodsFor: '*ma-core' stamp: 'cmm 9/13/2007 17:19'!
totalFileSize
	"Answer the cumulative size of all files and folders in the directories I contain, including their totalFileSize."
	^ self fileSizeStat sum ifNil: [ 0 ]! !

!DirectoryEntryFile methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:54'!
contributeStatisticsTo: aDirectoryEntryDirectory 
	"Add my size information to the cumulative total in aDirectoryEntryDirectory."
	aDirectoryEntryDirectory addToTotalSize: self fileSize! !

!DirectoryEntryFile methodsFor: '*ma-core' stamp: 'cmm 2/12/2009 18:44'!
directoryName
	"Answer the directory to shell to for this item."
	^ self containingDirectory pathName! !

!DirectoryEntryFile methodsFor: '*ma-core-private' stamp: 'cmm 9/13/2007 17:49'!
incrementDirectoryOrFileCount: twoElementArray 
	twoElementArray 
		at: 2
		put: (twoElementArray at: 2) + 1! !

!DirectoryEntryFile methodsFor: '*ma-core' stamp: 'cmm 10/11/2009 19:31'!
localFileName
	"For compatibility with ZipArchiveMember."
	^ self name! !

!DirectoryEntryFile methodsFor: '*ma-core' stamp: 'cmm 9/20/2007 17:07'!
totalFileSize
	"API compatible with DirectoryEntryDirectory>>#totalFileSize, but just answers my fileSize."
	^ self fileSize! !

Warning subclass: #MaWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Exceptions'!

!MaWarning methodsFor: 'as yet unclassified' stamp: 'cmm 11/13/2013 20:39'!
defaultAction
	Smalltalk isHeadless
		ifTrue: [ self resume ]
		ifFalse: [ super defaultAction ]! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 8/13/2009 21:33'!
maOn: exc1 do: block1 on: exc2 do: block2

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		on: exc2
		do: block2! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 8/13/2009 21:33'!
maOn: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		maOn: exc2
		do: block2

		on: exc3
		do: block3! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 11/20/2012 14:59'!
referencesDo: aBlock
	aBlock value: self receiver! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 11/19/2010 10:29'!
sentTo: anObject
	^ self value: anObject! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 7/13/2013 19:08'!
tempsDo: aBlock 
	1
		to: self outerContext basicSize
		do: [ : slot | aBlock value: (self outerContext tempAt: slot) ]! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 10/7/2010 20:35'!
valueWithAllArguments: anArray 
	"Same as valueWithPossibleArgs: except for a one-arg block, which is sure to pass all of anArray rather than just the first of its arguments.  This is used to allow a large, variable number of arguments to be passed."
	^numArgs = 0
		ifTrue: [self value]
		ifFalse:
			[self valueWithPossibleArgs:
				(numArgs = anArray size
					ifTrue: [anArray]
					ifFalse:
						[numArgs > anArray size
							ifTrue: [anArray, (Array new: numArgs - anArray size)]
							ifFalse:
								[numArgs = 1
									ifTrue: [Array with: anArray]
									ifFalse: [anArray copyFrom: 1 to: numArgs]]])]! !

!BlockClosure methodsFor: '*ma-core' stamp: 'cmm 8/12/2013 20:21'!
veryDeepInner: aDeepCopier 
	"Implement this method to avoid the default behavior.  Otherwise my context would attempt to be deepCopied which may be referencing a bunch of old execution state.  Can't think of any reason we'd ever want to deepCopy all that."
	super veryDeepInner: aDeepCopier! !

!Timespan methodsFor: '*ma-core' stamp: 'cmm 8/3/2010 22:58'!
maPrintAbbreviatedOn: aStream
	self printOn: aStream! !

!CompiledMethod methodsFor: '*ma-core' stamp: 'cmm 12/17/2008 20:29'!
maSourceString
	^ self getSource asString! !

!PositionableStream methodsFor: '*ma-core' stamp: 'cmm 4/2/2009 11:48'!
maReset
	"Reset my position back to the beginning."
	self reset.
	readLimit := collection size! !

!Number methodsFor: '*ma-core' stamp: 'cmm 7/18/2007 21:04'!
maLog: anInteger
	^ self log: anInteger! !

!Number methodsFor: '*ma-core' stamp: 'cm 12/24/2001 16:40'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 8/13/2009 21:53'!
hostNumber
	"This is here for Pharo compatibility.  It is overridden by Pharo's SocketAddress."
	^ String streamContents: 
		[ : stream | 
		self do: 
			[ : each | 
			stream maPrint: each.
			each = self last ifFalse: [ stream maPrint: $. ] ] ]! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 6/8/2008 20:55'!
lzCompressed
	| compressor compressed |
	compressed := RWBinaryOrTextStream on: ByteArray new.
	compressor := GZipWriteStream on: compressed.
	compressor nextPutAll: self.
	compressor close.
	^ compressed contents! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 6/8/2008 21:11'!
lzUncompressed
	"I am a ByteArray compressed with lzCompress.  Answer its original, uncompressed, form."
	| compressed |
	compressed := ReadStream on: self.
	^ (GZipReadStream on: compressed) contents! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 8/13/2009 21:53'!
maAsIpString
	"Answer the receiver as a dot-delimited ip address String."
	^ self hostNumber! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 8/13/2009 22:31'!
maIsLocalHost
	"Host addresses are represented as ByteArray's in Squeak.  Answer whether this host-address represents a localhost address."
	"Efficiently check whether the initial host-address is 127, which is assumed to be the localhost."
	self maAsIpString in: 
		[ : str | 
		(str first = $1 and: [ str second = $2 and: [ str third = $7 ] ]) ifTrue: [ ^ true ] ].
	^ self = NetNameResolver localHostAddress! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 8/10/2010 17:49'!
maUint: bits at: anInteger 
	"oids"
	| answer bytes |
	bits == 48 ifTrue: [ ^ self maUnsigned48At: anInteger + 1 ].
	"physicalSize, word buffers"
	bits == 32 ifTrue: 
		[ ^ self 
			unsignedLongAt: anInteger + 1
			bigEndian: false ].
	"control fields - bpMapIndex."
	bits == 8 ifTrue: [ ^ self byteAt: anInteger + 1 ].
	"class ids and classVersions"
	bits == 16 ifTrue: 
		[ ^ self 
			unsignedShortAt: anInteger + 1
			bigEndian: false ].
	bits == 24 ifTrue: [ ^ self maUnsigned24At: anInteger + 1 ].
	bits == 64 ifTrue: [ ^ self maUnsigned64At: anInteger + 1 ].
	bits == 40 ifTrue: [ ^ self maUnsigned40At: anInteger + 1 ].
	bits == 56 ifTrue: [ ^ self maUnsigned56At: anInteger + 1 ].
	bytes := bits // 8.
	answer := LargePositiveInteger new: bytes.
	1 
		to: bytes
		do: 
			[ : digitPosition | 
			answer 
				digitAt: digitPosition
				put: (self at: digitPosition + anInteger) ].
	^ answer normalize! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 3/18/2005 10:30'!
maUint: bits at: position put: anInteger

	position + 1
		to: position + (bits // 8)
		do:
			[ :pos |
			self
				at: pos
				put: (anInteger digitAt: pos-position) ].
	^anInteger! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 12/19/2008 14:30'!
maUnsigned24At: index
	"Return a 40-bit unsigned integer quantity starting from the given byte index"
	| b0 b1 w |
	w := self at: index.
	b1 := self at: index+1.
	b0 := self at: index+2.
	b1 = 0 ifFalse:[w := (b1 bitShift: 8) + w].
	b0 = 0 ifFalse:[w := (b0 bitShift: 16) + w].
	^w! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 12/12/2008 16:09'!
maUnsigned40At: index
	"Return a 40-bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 w |

	w := self at: index.
	b3 := self at: index+1.
	b2 := self at: index+2.
	b1 := self at: index+3.
	b0 := self at: index+4.

	"Minimize LargeInteger arithmetic"
	b3 = 0 ifFalse:[w := (b3 bitShift: 8) + w].
	b2 = 0 ifFalse:[w := (b2 bitShift: 16) + w].
	b1 = 0 ifFalse:[w := (b1 bitShift: 24) + w].
	b0 = 0 ifFalse:[w := (b0 bitShift: 32) + w].

	^w! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 12/12/2008 16:09'!
maUnsigned48At: index
	"Return a 48-bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 w |

	w := self at: index.
	b4 := self at: index+1.
	b3 := self at: index+2.
	b2 := self at: index+3.
	b1 := self at: index+4.
	b0 := self at: index+5.

	"Minimize LargeInteger arithmetic"
	b4 = 0 ifFalse:[w := (b4 bitShift: 8) + w].
	b3 = 0 ifFalse:[w := (b3 bitShift: 16) + w].
	b2 = 0 ifFalse:[w := (b2 bitShift: 24) + w].
	b1 = 0 ifFalse:[w := (b1 bitShift: 32) + w].
	b0 = 0 ifFalse:[w := (b0 bitShift: 40) + w].

	^w! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 12/12/2008 16:08'!
maUnsigned56At: index
	"Return a 56-bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 b5 w |

	w := self at: index.
	b5 := self at: index+1.
	b4 := self at: index+2.
	b3 := self at: index+3.
	b2 := self at: index+4.
	b1 := self at: index+5.
	b0 := self at: index+6.

	"Minimize LargeInteger arithmetic"
	b5 = 0 ifFalse:[w := (b5 bitShift: 8) + w].
	b4 = 0 ifFalse:[w := (b4 bitShift: 16) + w].
	b3 = 0 ifFalse:[w := (b3 bitShift: 24) + w].
	b2 = 0 ifFalse:[w := (b2 bitShift: 32) + w].
	b1 = 0 ifFalse:[w := (b1 bitShift: 40) + w].
	b0 = 0 ifFalse:[w := (b0 bitShift: 48) + w].

	^w! !

!ByteArray methodsFor: '*ma-core' stamp: 'cmm 3/18/2005 09:59'!
maUnsigned64At: index
	"Return a 32bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 b5 b6 w |

	w := self at: index.
	b6 := self at: index+1.
	b5 := self at: index+2.
	b4 := self at: index+3.
	b3 := self at: index+4.
	b2 := self at: index+5.
	b1 := self at: index+6.
	b0 := self at: index+7.

	"Minimize LargeInteger arithmetic"
	b6 = 0 ifFalse:[w := (b6 bitShift: 8) + w].
	b5 = 0 ifFalse:[w := (b5 bitShift: 16) + w].
	b4 = 0 ifFalse:[w := (b4 bitShift: 24) + w].
	b3 = 0 ifFalse:[w := (b3 bitShift: 32) + w].
	b2 = 0 ifFalse:[w := (b2 bitShift: 40) + w].
	b1 = 0 ifFalse:[w := (b1 bitShift: 48) + w].
	b0 = 0 ifFalse:[w := (b0 bitShift: 56) + w].

	^w! !

!Behavior methodsFor: '*ma-core' stamp: 'cmm 12/2/2004 15:07'!
maAllInstVarNamesDo: aBlock

	superclass ifNotNil: [ superclass maAllInstVarNamesDo: aBlock ].
	self instVarNames do: aBlock! !

!Behavior methodsFor: '*ma-core' stamp: 'cmm 12/16/2004 01:26'!
maAllSelectorsDo: aBlock

	self selectorsDo: aBlock.
	superclass ifNotNil: [ superclass maAllSelectorsDo: aBlock ]! !

!Behavior methodsFor: '*ma-core' stamp: 'cmm 12/3/2007 21:13'!
maFirstCommentAt: selector 
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."
	^ (self methodDict includesKey: selector) 
		ifTrue: [ self firstCommentAt: selector ]
		ifFalse: 
			[ self superclass 
				ifNil: [ '' ]
				ifNotNil: [ self superclass maFirstCommentAt: selector ] ]! !

!Behavior methodsFor: '*ma-core' stamp: 'cmm 11/19/2003 22:53'!
maFirstCommentOrNilAt: selector
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."

	| string |
	^(string := self maFirstCommentAt: selector) isEmpty
		ifTrue: [ nil ]
		ifFalse: [ string ]! !

!SortedCollection methodsFor: '*ma-core' stamp: 'cmm 7/15/2006 15:12'!
maIsSortedCollection
	^ true! !

!Process methodsFor: '*ma-core' stamp: 'cmm 11/10/2010 14:19'!
everStarted
	^ self isSuspended not or: [ self isTerminated ]! !

!SharedQueue methodsFor: '*ma-core' stamp: 'cmm 2/8/2005 23:34'!
notEmpty

	^ self isEmpty not! !

!MCDirectoryRepository methodsFor: '*ma-core' stamp: 'cmm 3/18/2009 21:09'!
isDirectoryRepository
	^ true! !

!SystemNavigation class methodsFor: '*ma-core' stamp: 'cmm 3/3/2004 22:57'!
maDefault: aSystemNavigation

	Default := aSystemNavigation! !

!SystemNavigation methodsFor: '*ma-core' stamp: 'cmm 1/2/2005 23:31'!
maAllMethodReferencesDo: aBlock
	"Value aBlock for every method in the system."
	Cursor execute showWhile:
		[ self
			allBehaviorsDo:
				[ : class |
				class selectorsDo:
					[ : sel | 
					aBlock value: (MethodReference class: class selector: sel) ] ] ]! !

!TimeProfileBrowser class methodsFor: '*ma-core' stamp: 'cmm 12/24/2003 13:25'!
maOnBlock: block if: conditionBlock
	"Allows you to build up your sample set before invoking the profiler."
	^conditionBlock value 
		ifTrue: [ self onBlock: block ]
		ifFalse: [ block value ]! !

!Collection methodsFor: '*ma-core' stamp: 'cmm 7/9/2002 22:59'!
maConsistsOf: aCollection
	"Answer whether the receiver and aCollection reference all equal
	objects, including the same number of references to those objects.  Order
	is not a factor."

	^self size = aCollection size and: [ self maIncludesAll: aCollection ]
! !

!Collection methodsFor: '*ma-core' stamp: 'cmm 1/16/2002 16:48'!
maDetect: aBlock ifFound: foundBlock ifNone: exceptionBlock 
	"foundBlock takes one argument, the found object."

	self 
		do: [ :element | (aBlock value: element) ifTrue: [ ^foundBlock value: element ] ].
	^exceptionBlock value
! !

!Collection methodsFor: '*ma-core' stamp: 'cmm 7/24/2004 01:05'!
maDo: aBlock while: conditionBlock

	conditionBlock value ifFalse: [ ^ self ].
	self do:
		[ : each |
		aBlock value: each.
		conditionBlock value ifFalse: [ ^ self ] ]! !

!Collection methodsFor: '*ma-core' stamp: 'cmm 12/19/2002 21:32'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	self size > 20
		ifTrue:
			[ ^self asBag maIncludesAll: aCollection ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Collection methodsFor: '*ma-core' stamp: ''!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection.  In SequencableCollections, the order must be
	the same as well."

	^self maConsistsOf: anotherCollection
! !

!Collection methodsFor: '*ma-core' stamp: 'cmm 8/4/2013 20:08'!
maPrintDescription
	| msg |
	super mauiName size < 40 ifTrue: [ ^ super mauiName ].
	msg := MaUserMessage new.
	self isEmpty ifTrue:
		[ msg append:
			(self class name first isVowel
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]).
		msg append: 'empty '.
		msg append: self maOriginalClass name ].
	self isEmpty ifFalse:
		[ | lowestCommonSuperclass |
"		msg append: ' of '."
		msg
			 append: self size asString ;
			 space.
		lowestCommonSuperclass := self
			inject: self anyOne maOriginalClass
			into:
				[ : common : each | (each maOriginalClass == common or: [ each maOriginalClass inheritsFrom: common ])
					ifTrue: [ common ]
					ifFalse: [ each maOriginalClass maLowestCommonSuperclassWith: common ] ].
		msg
			appendProperlyPluralized: lowestCommonSuperclass name
			for: self size ].
	^ msg messageText! !

!Collection methodsFor: '*ma-core' stamp: ''!
maRemoveAll: aCollection forEachAbsent: aBlock

	^aCollection do:
		[ :element |
		self
			remove: element
			ifAbsent: [ aBlock value: element ] ]
! !

!BlockContext methodsFor: '*ma-core' stamp: 'cmm 3/23/2003 22:40'!
maOn: exc1 do: block1 on: exc2 do: block2

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		on: exc2
		do: block2! !

!BlockContext methodsFor: '*ma-core' stamp: 'cmm 3/23/2003 22:43'!
maOn: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		maOn: exc2
		do: block2

		on: exc3
		do: block3! !

SharedPool subclass: #MaCoreConstants
	instanceVariableNames: ''
	classVariableNames: 'HasMagma'
	poolDictionaries: ''
	category: 'Ma-Core-Constants'!

!MaCoreConstants class methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2012 13:13'!
initialize
	HasMagma := false! !

MaNotification subclass: #MagmaSessionRequest
	instanceVariableNames: 'doBlock'
	classVariableNames: ''
	poolDictionaries: 'MaCoreConstants'
	category: 'Ma-Core-Requests'!

!MagmaSessionRequest commentStamp: 'cmm 1/13/2005 23:08' prior: 0!
I am used to signal to the session controller a session directive, such as connect, commit, abort, disconnect, or others.

Use my class-side api in your domain code.  For example, in your setters:

	name: aString
		MagmaSessionRequest signalCommit: [ name _ aString ]

When Magma is not used, the session request has no effect.!

!MagmaSessionRequest class methodsFor: 'private' stamp: 'cmm 4/22/2003 23:41'!
signal: aString do: oneArgBlock
	"oneArgBlock takes the session that you wish to do something to."

	^self new
		messageText: aString;
		doBlock: oneArgBlock;
		signal! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/24/2003 15:00'!
signalAbort

	self 
		signal: 'aborting transaction'
		do: [ :session | session abort ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:42'!
signalBegin

	self 
		signal: 'beginning transaction'
		do: [ :session | session begin ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:43'!
signalCommit

	self 
		signal: 'committing transaction'
		do: [ :session | session commit ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 6/22/2012 13:08'!
signalCommit: aBlock 
	| result |
	self signalBegin.
	result := HasMagma
		ifTrue: [ aBlock valueWhileObservingStateChange ]
		ifFalse: [ aBlock value ].
	self signalCommit.
	^ result! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:50'!
signalCommitAndBegin

	self 
		signal: 'committing transaction and beginning a new one'
		do: [ :session | session commitAndBegin ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 9/1/2010 13:09'!
signalNewGlobalReadStrategy: aMaReadStrategy
	self 
		signal: 'setting global read-strategy'
		do: [ :session | session globalReadStrategy: aMaReadStrategy ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 7/17/2010 17:56'!
signalNewReadStrategy: aMaReadStrategy
	self 
		signal: 'setting read-strategy'
		do: [ :session | session readStrategy: aMaReadStrategy ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 8/2/2009 17:06'!
signalNoteOldKeysFor: anObject 
	self 
		signal: 'noting old keys'
		do: [ : session | session noteOldKeysFor: anObject ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 11/18/2010 18:21'!
signalRefresh
	self
		signal: 'refreshing repository view'
		do: [ : session | session refresh ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 10/13/2012 23:00'!
signalSetRetrySeconds: anInteger
	self 
		signal: 'setting retrySeconds to ', anInteger
		do: [ :session | session retrySeconds: anInteger ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 7/4/2012 14:33'!
signalSetTimeoutSeconds: anInteger
	self 
		signal: 'setting timeout to ', anInteger, ' seconds'
		do: [ :session | session timeoutSeconds: anInteger ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 8/2/2009 17:06'!
signalStubOut: anObject 
	self 
		signal: 'stub out'
		do: [ : session | session stubOut: anObject ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 3/13/2013 15:15'!
signalStubOutAll: aCollection 
	self 
		signal: 'stub out ', aCollection size, ' objects.'
		do: [ : session | session stubOutAll: aCollection ]! !

!MagmaSessionRequest methodsFor: 'private' stamp: 'cmm 3/20/2003 01:05'!
doBlock: oneArgBlock

	doBlock := oneArgBlock! !

!MagmaSessionRequest methodsFor: 'handler' stamp: 'cmm 9/8/2012 17:58'!
handleAndResumeUsing: aMagmaSession 
	self resume: (self handleUsing: aMagmaSession)! !

!MagmaSessionRequest methodsFor: 'handler' stamp: 'cmm 9/8/2012 17:57'!
handleUsing: aMagmaSession 
	aMagmaSession ifNotNil: [ doBlock value: aMagmaSession ]! !

!Date methodsFor: '*ma-core' stamp: 'cmm 7/29/2008 23:14'!
maAddYears: anInteger 
	"Answer a new date anInteger years after or, if anInteger is negative, before, the receiver."
	^ Date 
		newDay: self dayOfMonth
		month: self monthIndex
		year: self year + anInteger! !

!Date methodsFor: '*ma-core' stamp: 'cmm 6/17/2010 15:29'!
maSuggestedFilename 
	^ self yyyymmdd asFileName! !

!Rectangle class methodsFor: '*ma-core' stamp: 'cmm 9/30/2009 14:08'!
maFullyInverted
	^ self 
		origin: Float infinity @ Float infinity
		corner: Float infinity negated @ Float infinity negated! !

!Rectangle methodsFor: '*ma-core' stamp: 'cmm 10/30/2009 22:57'!
isInverted
	^ origin x > corner x! !

!Rectangle methodsFor: '*ma-core' stamp: 'cmm 4/9/2010 12:55'!
maCloseTo: aRectangle 
	^ (aRectangle topLeft maCloseTo: self topLeft) and: [ aRectangle bottomRight maCloseTo: self bottomRight ]! !

!Rectangle methodsFor: '*ma-core' stamp: 'cmm 6/5/2010 22:27'!
maLongestSide
	^ self width max: self height! !

!Rectangle methodsFor: '*ma-core' stamp: 'cmm 6/23/2010 22:52'!
maPointAtRandom
	^(self topLeft x + (self width * Collection randomForPicking next)) @ (self topLeft y + (self height * Collection randomForPicking next))! !

!Rectangle methodsFor: '*ma-core' stamp: 'cmm 3/27/2010 15:37'!
maPreciseCenter
	"Same as #center, but usable for Rectangles specified by Floating points, in that it does not truncate to an Integer as #center does."
	^self topLeft + self bottomRight / 2! !

!MCRepository methodsFor: '*ma-core' stamp: 'cmm 3/18/2009 21:10'!
isDirectoryRepository
	^ false! !

!ServerDirectory methodsFor: '*ma-core' stamp: 'cmm 4/4/2007 09:43'!
assureAbsence
	self exists ifTrue: [ self recursiveDelete ]! !

!ServerDirectory methodsFor: '*ma-core' stamp: 'cmm 4/4/2007 17:20'!
maCopyFileNamed: sourceFilename toDirectory: aFileDirectory 
	| sourceStream |
	sourceStream := (self readOnlyFileNamed: sourceFilename) binary.
	^ [ aFileDirectory 
		putFile: sourceStream
		named: (aFileDirectory localNameFor: sourceFilename) ]

		ensure: [ sourceStream close ]! !

Object subclass: #MaObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Abstractions'!

!MaObject commentStamp: 'cmm 10/25/2005 22:43' prior: 0!
I provide automatic initialization (which was later added to Squeak 3.7), and the notion of a verbose (standard printOn:) and concise (maPrintAbbreviatedOn:) forms for brevity in collections.!

MaObject subclass: #MaAttributableObject
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Abstractions'!

!MaAttributableObject commentStamp: 'cmm 10/7/2009 21:03' prior: 0!
Subclass from this abstract class to inherit an attribute Dictionary.!

!MaAttributableObject methodsFor: 'attributes' stamp: 'cmm 4/9/2010 14:43'!
attributeNamed: aString 
	^ attributes ifNotNil: 
		[ attributes 
			at: aString
			ifAbsent: [ nil ] ]! !

!MaAttributableObject methodsFor: 'attributes' stamp: 'cmm 7/4/2013 20:18'!
attributeNamed: aString put: anObject 
	anObject ifNotNil: [ attributes ifNil: [ attributes := Dictionary new ] ].
	^ anObject
		ifNil:
			[ self removeAttributeNamed: aString.
			anObject ]
		ifNotNil:
			[ attributes
				at: aString
				put: anObject ]! !

!MaAttributableObject methodsFor: 'copying' stamp: 'cmm 1/16/2012 16:39'!
attributesToDeepCopy
	"Subclasses override."
	^ attributes
		ifNil: [ Array empty ]
		ifNotNil: [ attributes keys ]! !

!MaAttributableObject methodsFor: 'attributes' stamp: 'cmm 4/9/2010 14:42'!
hasAttributeNamed: aString 
	^ attributes 
		ifNil: [ false ]
		ifNotNil: [ attributes includesKey: aString ]! !

!MaAttributableObject methodsFor: 'remember/restore' stamp: 'cmm 12/7/2009 17:02'!
rememberAttributes
	"Remember my current attributes as an attribute called, #priorAttributes."
	| priorAttributes |
	(self attributeNamed: #priorAttributes) ifNotNil: [ MaUserError signal: 'priorAttributes already present' ].
	priorAttributes := attributes.
	attributes := attributes copy.
	self 
		attributeNamed: #priorAttributes
		put: priorAttributes! !

!MaAttributableObject methodsFor: 'attributes' stamp: 'cmm 10/7/2009 21:02'!
removeAttributeNamed: aString 
	^ attributes ifNotNil: 
		[ | answer |
		answer := attributes 
			removeKey: aString
			ifAbsent: [ nil ].
		attributes ifEmpty: [ attributes := nil ].
		answer ]! !

!MaAttributableObject methodsFor: 'remember/restore' stamp: 'cmm 10/28/2011 15:38'!
restoreAttributes
	"Restore my prior-attributes which were remembered via #rememberAttributes."
	attributes 
		at: #priorAttributes
		ifPresent: [ : foundAttributes | attributes := foundAttributes ]
		ifAbsent: 
			[ "there were no attributes when rememberAttributes was called"
			 ]! !

!MaAttributableObject methodsFor: 'copying' stamp: 'cmm 7/4/2013 20:25'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	attributes := attributes copy.
	self attributesToDeepCopy do:
		[ : eachAttribute | attributes
			at: eachAttribute
			ifPresent:
				[ : value | attributes
					at: eachAttribute
					put: (value veryDeepCopyWith: aDeepCopier) ]
			ifAbsent: [ self error: eachAttribute , ' is not an attribute.' ] ]! !

MaObject subclass: #MaCommandLineProcessor
	instanceVariableNames: ''
	classVariableNames: 'QuitOnError'
	poolDictionaries: ''
	category: 'Ma-Core-Utilities'!

!MaCommandLineProcessor commentStamp: 'cmm 5/25/2010 12:37' prior: 0!
MaCommandLineProcessor is a place for Smalltalk scripts to be called via command-line.!

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 10/12/2013 16:25'!
args
	"Answer an Array of the command-line arguments passed in."
	| stream |
self maMarked: 'delete'.
	stream := WriteStream on: Array new.
	3
		to: 1000
		do:
			[ : n | (SmalltalkImage current getSystemAttribute: n)
				ifNil: [ ^ stream contents ]
				ifNotNilDo:
					[ : arg | stream nextPut: arg ] ]! !

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 10/12/2013 16:25'!
do: aBlock 
	self ensureStartedUp.
	[ [ aBlock valueWithAllArguments: Smalltalk arguments ]
		on: ProgressInitiationException
		do:
			[ : pie | "Don't want to log this notification."
			pie defaultAction ] ]
		on: Notification , Warning
		do:
			[ : noti | StandardFileStream stdout
				 nextPutAll: DateAndTime now asString ;
				 space ;
				 nextPutAll: noti description ;
				 cr.
			noti resume ]
		on: SyntaxErrorNotification
		do:
			[ : err | StandardFileStream stdout
				 nextPutAll: err errorCode ;
				 cr.
			self haltOrQuit ]
		on: Error
		do:
			[ : err | err printVerboseOn: StandardFileStream stderr.
			self haltOrQuit.
			err isResumable ifTrue: [ err resume ] ]! !

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 10/30/2010 20:34'!
do: aBlock snapshotAs: imageName andQuit: shouldQuit 
	self do: aBlock.
	imageName
		ifNil:
			[ shouldQuit ifTrue:
				[ Smalltalk
					snapshot: false
					andQuit: shouldQuit ] ]
		ifNotNil:
			[ | fixedName |
			fixedName := (imageName endsWith: '.image')
				ifTrue: [ imageName ]
				ifFalse: [ imageName , '.image' ].
			(FileDirectory default fullNameFor: fixedName) = Smalltalk imageName
				ifTrue:
					[ Smalltalk
						snapshot: true
						andQuit: shouldQuit ]
				ifFalse:
					[ Smalltalk maSaveAs: imageName.
					"Avoid instant-quit when relaunching by resaving."
					shouldQuit ifTrue:
						[ Smalltalk
							snapshot: true
							andQuit: shouldQuit ] ] ]! !

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 10/30/2010 20:25'!
doAndQuit: aBlock 
	self
		do: aBlock
		snapshotAs: nil
		andQuit: true! !

!MaCommandLineProcessor class methodsFor: 'private' stamp: 'cmm 4/2/2013 18:19'!
ensureStartedUp
	#(#FileStream #ThisOSProcess #MagmaRepositoryController ) do: [ : each | self ensureStartedUp: each ]! !

!MaCommandLineProcessor class methodsFor: 'private' stamp: 'cmm 6/21/2010 23:22'!
ensureStartedUp: className 
	(Smalltalk hasClassNamed: className) ifTrue: [ (Smalltalk classNamed: className) startUp: true ]! !

!MaCommandLineProcessor class methodsFor: 'private' stamp: 'cmm 11/13/2013 20:39'!
haltOrQuit
	(QuitOnError or: [ Smalltalk isHeadless ])
		ifTrue: [ self quit ]
		ifFalse: [ self halt ]! !

!MaCommandLineProcessor class methodsFor: 'initialize-release' stamp: 'cmm 5/13/2013 13:59'!
initialize
	QuitOnError := true! !

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 5/25/2010 12:39'!
quit
	SmalltalkImage current
		snapshot: false
		andQuit: true! !

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 3/8/2013 12:04'!
quitOnError
	^ QuitOnError! !

!MaCommandLineProcessor class methodsFor: 'api' stamp: 'cmm 3/8/2013 12:04'!
quitOnError: aBoolean
	QuitOnError := aBoolean! !

!MaObject class methodsFor: 'testing' stamp: 'cmm 6/18/2011 14:25'!
hasMaui
	"Answer whether some version of Maui is installed on this system."
	^ Smalltalk hasClassNamed: #MauiWorld! !

!MaObject methodsFor: 'printing' stamp: 'cmm 2/28/2013 21:00'!
abbreviation
	^ self maOriginalClass abbreviation! !

!MaObject methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:13'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !

MaObject subclass: #MaObjectComparison
	instanceVariableNames: 'object1 object2 comparisonOperator differences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Utilities'!

!MaObjectComparison class methodsFor: 'create' stamp: 'cmm 11/26/2012 21:07'!
with: firstObject with: secondObject 
	^ self new
		
		setObject1: firstObject
		object2: secondObject ;
		 yourself! !

!MaObjectComparison methodsFor: 'accessing' stamp: 'cmm 11/26/2012 21:11'!
comparisonOperator
	^ comparisonOperator! !

!MaObjectComparison methodsFor: 'accessing' stamp: 'cmm 11/26/2012 21:10'!
comparisonOperator: operatorSymbol
	comparisonOperator = operatorSymbol ifFalse:
		[ comparisonOperator := operatorSymbol.
		self resetDifferences ]! !

!MaObjectComparison methodsFor: 'testing' stamp: 'cmm 4/6/2013 17:23'!
differenceKeys
	"The attributes which are different."
	^ self differences collect: [ : each | each key ]! !

!MaObjectComparison methodsFor: 'testing' stamp: 'cmm 12/19/2012 17:04'!
differences
	^ differences ifNil:
		[ differences := self object1
			differencesWith: self object2
			using: comparisonOperator ]! !

!MaObjectComparison methodsFor: 'testing' stamp: 'cmm 11/26/2012 21:13'!
differencesFor: differencesKey 
	^ self differences
		at: differencesKey
		ifAbsent: [ Array empty ]! !

!MaObjectComparison methodsFor: 'testing' stamp: 'cmm 11/26/2012 21:12'!
differsBy: differencesKey
	^ self differences includesKey: differencesKey! !

!MaObjectComparison methodsFor: 'testing' stamp: 'cmm 4/6/2013 17:23'!
differsByOtherThan: allowedKeys 
	"Answer whether my objects differ by attributes _besides_ the ones specified by allowedKeys."
	| allowedCollection |
	allowedCollection := allowedKeys asCollection.
	^ self differenceKeys anySatisfy:
		[ : each | (allowedCollection includes: each) not ]! !

!MaObjectComparison methodsFor: 'initializing' stamp: 'cmm 11/26/2012 21:16'!
initialize
	super initialize.
	comparisonOperator := #=.
	self resetDifferences! !

!MaObjectComparison methodsFor: 'accessing' stamp: 'cmm 11/26/2012 21:06'!
object1
	^ object1! !

!MaObjectComparison methodsFor: 'accessing' stamp: 'cmm 11/26/2012 21:06'!
object2
	^ object2! !

!MaObjectComparison methodsFor: 'private' stamp: 'cmm 11/26/2012 21:09'!
resetDifferences
	differences := nil! !

!MaObjectComparison methodsFor: 'initializing' stamp: 'cmm 11/26/2012 21:07'!
setObject1: firstObject object2: secondObject 
	object1 := firstObject.
	object2 := secondObject! !

MaObject subclass: #MaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Abstractions'!

MaSingleton class
	instanceVariableNames: 'current'!

MaSingleton class
	instanceVariableNames: 'current'!

!MaSingleton class methodsFor: 'accessing' stamp: 'cmm 11/23/2010 23:51'!
current
	^ current ifNil:
		[ self current: self new.
		current ]! !

!MaSingleton class methodsFor: 'accessing' stamp: 'cmm 11/18/2010 13:11'!
current: anObject
	current := anObject! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 1/10/2005 21:54'!
initialize

	super initialize.
	self reset! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 4/22/2011 14:31'!
reset
	self current: nil! !

MaObject subclass: #MaStat
	instanceVariableNames: 'last min max count sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Domain'!

!MaStat commentStamp: 'cmm 5/6/2008 12:31' prior: 0!
The name, "MaStat" is purposefully abbreviated because its capability, itself, is abbreviated.  It is not intended to ever develop into a "statistics framework", only to serve basic statistical purposes.!

!MaStat class methodsFor: 'as yet unclassified' stamp: 'cmm 12/23/2008 18:53'!
defaultPrecision
	^ 0.001! !

!MaStat class methodsFor: 'as yet unclassified' stamp: 'cmm 11/16/2004 10:51'!
example

	| stat |
	stat := self new.
	#(1 2 5 8 9 15) do: [ :each | stat addValue: each ].
	stat! !

!MaStat methodsFor: 'summarize' stamp: 'cmm 7/13/2009 18:06'!
+ aMaStat 
	| n x c s |
	n := self min 
		ifNil: [ aMaStat min ]
		ifNotNil: 
			[ aMaStat min 
				ifNil: [ self min ]
				ifNotNil: [ self min min: aMaStat min ] ].
	x := self max 
		ifNil: [ aMaStat max ]
		ifNotNil: 
			[ aMaStat max 
				ifNil: [ self max ]
				ifNotNil: [ self max max: aMaStat max ] ].
	c := self count 
		ifNil: [ aMaStat count ]
		ifNotNil: 
			[ aMaStat count 
				ifNil: [ self count ]
				ifNotNil: [ self count + aMaStat count ] ].
	s := self sum 
		ifNil: [ aMaStat sum ]
		ifNotNil: 
			[ aMaStat sum 
				ifNil: [ self sum ]
				ifNotNil: [ self sum + aMaStat sum ] ].
	^ self maOriginalClass new 
		setLast: aMaStat last
		min: n
		max: x
		count: c
		sum: s! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 5/7/2008 15:36'!
addValue: aMagnitude 
	"This is named addValue: instead of add: to be easier to find senders."
	last := aMagnitude.
	count := count + 1.
	min := min 
		ifNil: [ aMagnitude ]
		ifNotNil: [ min min: aMagnitude ].
	max := max 
		ifNil: [ aMagnitude ]
		ifNotNil: [ max max: aMagnitude ].
	sum := sum 
		ifNil: [ aMagnitude ]
		ifNotNil: [ sum + aMagnitude ].
	^ aMagnitude! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 9/28/2007 12:31'!
count
	"The number of values."
	^count! !

!MaStat methodsFor: 'initialize' stamp: 'cmm 4/28/2008 22:56'!
initialize
	super initialize.
	count := last := 0! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 9/28/2007 12:33'!
last
	"The last value recorded."
	^ last! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 11/16/2004 21:50'!
last: aMagnitude

	last := aMagnitude! !

!MaStat methodsFor: 'printing' stamp: 'cmm 11/16/2004 21:52'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(min max sum count mean)
		on: aStream! !

!MaStat methodsFor: 'maui support' stamp: 'cmm 12/22/2008 14:04'!
mauiDefaultColumns
	^ #(#count #min #max #mean #sum #last )! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 9/27/2007 17:23'!
max
	"The highest value."
	^max! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 12/8/2009 10:36'!
mean
	"The average value."
	^ (sum isNil or: [ count isNil ]) 
		ifTrue: [ nil ]
		ifFalse: [ sum / count asFloat roundTo: self class defaultPrecision ]! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 9/27/2007 17:23'!
min
	"The minimum value."
	^min! !

!MaStat methodsFor: 'initialize' stamp: 'cmm 4/28/2008 22:29'!
setLast: newLast min: newMin max: newMax count: newCount sum: newSum 
	last := newLast.
	min := newMin.
	max := newMax.
	count := newCount.
	sum := newSum! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 9/27/2007 17:24'!
sum
	"The sum of all values."
	^ sum! !

MaObject subclass: #MaTimer
	instanceVariableNames: 'name process monitor expired delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Utilities'!

!MaTimer commentStamp: 'cmm 5/2/2008 11:59' prior: 0!
A very simple class to perform a Block after a specified amount of time.  #cancel will stop the countdown.  #expired answers true if the timer expired and the do Block executed.!

!MaTimer class methodsFor: 'as yet unclassified' stamp: 'cmm 5/10/2008 13:09'!
unload
	self allInstancesDo: [ : each | each cancel ]! !

!MaTimer methodsFor: 'access' stamp: 'cmm 6/4/2008 08:55'!
cancel
	"Only allow termination while the delay is running, not while the do block is running."
	process ifNil: [ ^ self ].
	expired ifTrue: 
		[ "There's no canceling now..!!"
		^ self ].
	"Don't allow process to terminate itself."
	process == Processor activeProcess ifTrue: [ MaSoftwareError signal: 'Do not cancel from this process!!' ].
	monitor 
		ifNil: [ process terminate ]
		ifNotNil: [ monitor critical: [ process terminate ] ].
	process := nil! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/15/2008 17:42'!
expired
	"Answer whether the waiting period before executing my do block has elapsed.  It does not indicate whether the do block has executed or not."
	^ self started and: [ monitor critical: [ expired ] ]! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/19/2008 14:19'!
in: aDuration do: aBlock 
	process := 
	[ monitor := Mutex new.
	expired := false.
	delay := (Delay forDuration: aDuration) wait.
	name ifNil: [ name := 'MaTimer for ' , aDuration printString ].
	monitor critical: 
		[ expired := true.
		aBlock value ] ] newProcess.
	process
		name: self name ;
		priority: Processor userInterruptPriority-1.
	process resume! !

!MaTimer methodsFor: 'initialize' stamp: 'cmm 3/7/2008 17:08'!
initialize
	super initialize.
	expired := false! !

!MaTimer methodsFor: 'access' stamp: 'cmm 6/5/2008 22:10'!
name
	^name! !

!MaTimer methodsFor: 'access' stamp: 'cmm 9/16/2013 10:44'!
name: aString
	name := aString! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/15/2008 17:42'!
resetDelay
	"If I am still counting down to ding, reset my Delay timer back to the original duration.  Otherwise, do nothing.  
	This might make me useful as a countdown timer to disconnect after a period of inactivity."
	self started ifFalse: [ ^ self ].	"not yet started.."
	monitor critical: [ delay ifNotNil: [ delay maReset ] ]! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/15/2008 17:41'!
started
	^ monitor notNil! !

MaObject subclass: #MaUserMessage
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Utilities'!

!MaUserMessage commentStamp: '<historical>' prior: 0!
This little tool helps you build non-wimpy message strings.!

!MaUserMessage methodsFor: 'building' stamp: 'cmm 3/6/2002 22:47'!
append: aString

	self appendString: aString
! !

!MaUserMessage methodsFor: 'building' stamp: 'cmm 8/4/2013 20:07'!
appendAndedList: aCollection

	self
		appendList: (
			aCollection
				collect: [ :each | each isString ifTrue: [ each ] ifFalse: [ each printString ] ])
		with: 'and'
! !

!MaUserMessage methodsFor: 'building' stamp: ''!
appendCount: aNumber of: aString
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self
		append: aNumber;
		space.
	self
		appendProperlyPluralized: aString
		for: aNumber
! !

!MaUserMessage methodsFor: 'private initializing' stamp: 'cmm 3/18/2013 10:29'!
appendList: aCollection with: aString 
	| index |
	aCollection isEmpty ifTrue: [ ^ nil ].
	index := 1.
	aCollection do:
		[ : each | self append: each.
		aCollection size > 1 ifTrue:
			[ index < (aCollection size - 1)
				ifTrue: [ self append: ', ' ]
				ifFalse:
					[ index = (aCollection size - 1) ifTrue:
						[ self
							 space ;
							 append: aString ;
							 space ] ] ].
		index := index + 1 ]! !

!MaUserMessage methodsFor: 'building' stamp: 'cmm 11/25/2003 00:19'!
appendProperlyPluralized: aString for: aNumber
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self append: aString.
	aString last asLowercase = $s
		ifTrue: [ stream nextPut: $' ]
		ifFalse: [ stream nextPut: $s ]! !

!MaUserMessage methodsFor: 'private building' stamp: 'cmm 11/25/2003 00:17'!
appendString: anObject

	anObject isString 
		ifTrue: [ stream nextPutAll: anObject ] 
		ifFalse: [ anObject printOn: stream ]! !

!MaUserMessage methodsFor: 'private initializing' stamp: 'cmm 11/25/2003 00:16'!
initialize

	super initialize.
	stream := String new writeStream! !

!MaUserMessage methodsFor: 'accessing' stamp: 'cmm 11/25/2003 00:22'!
messageText

	stream last = $. ifFalse: [ stream nextPut: $. ].
	^stream contents
! !

!MaUserMessage methodsFor: 'building' stamp: 'cmm 12/27/2008 16:24'!
space
	self append: ' '! !

!MaUserMessage methodsFor: 'private accessing' stamp: 'cmm 11/25/2003 00:16'!
string

	^stream contents! !

MaObject subclass: #MauiIconSet
	instanceVariableNames: 'forms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Utilities'!

!MauiIconSet class methodsFor: 'more icons' stamp: 'cmm 2/8/2013 14:39'!
addIcon: aFormOrSketchMorph accessedBy: selector 
	"Compile a new 'access' method in me that will answer aFormOrSketchMorph as an icon."
	self 
		compile: 
			(self 
				methodSourceForIcon: aFormOrSketchMorph form
				named: selector)
		classified: 'icons'! !

!MauiIconSet class methodsFor: 'more icons' stamp: 'cmm 10/29/2007 13:13'!
methodSourceForIcon: aForm named: selectorSymbol 
	| formStream base64Stream |
	formStream := RWBinaryOrTextStream on: ByteArray new.
	PNGReadWriter 
		putForm: aForm
		onStream: formStream.
	base64Stream := Base64MimeConverter mimeEncode: formStream.
	^ String streamContents: 
		[ : stream | 
		stream
			nextPutAll: selectorSymbol ;
			nextPutAll: '
	^ self 
		iconNamed: #' ;
			nextPutAll: selectorSymbol ;
			nextPutAll: '
		ifAbsentPutFromString: ' ;
			nextPut: $' ;
			nextPutAll: base64Stream contents ;
			nextPut: $' ]! !

!MauiIconSet class methodsFor: 'browse' stamp: 'cmm 2/8/2013 14:18'!
seeMyIcons
	"Open palette of all my icons."
	| iconSelectors palette icons|
	palette := RectangleMorph new
		color: Color white ;
		layoutPolicy: TableLayout new ;
		listDirection: #leftToRight ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		wrapDirection: #topToBottom ;
		extent: World extent // 2 ;
		cellInset: 10 ;
		yourself.
	iconSelectors := ((self methodsInCategory: 'icons')  select: [ : e | e isUnary ]) asSortedCollection.
	icons := self new.
	iconSelectors do: 
		[ : each | | labelledIcon |
		labelledIcon := RectangleMorph new
			layoutPolicy: TableLayout new ;
			listDirection: #topToBottom ;
			layoutInset: 4 ;
			hResizing: #shrinkWrap ;
			vResizing: #shrinkWrap ;
			color: Color transparent ;
			borderWidth: 0 ;
			yourself.
		labelledIcon 
			addMorph: (StringMorph contents: each) ;
			addMorph: ("SketchMorph withForm:" (icons perform: each)).
		palette addMorphBack: labelledIcon ].
	palette openInWorld! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 12/16/2010 23:07'!
abort
	^ self 
		iconNamed: #abort
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAKEElEQVR4XtVXeVDTZxoOoAxq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'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:21'!
addIcon
	^ self
		iconNamed: #addIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAA0AAAANCAYAAABy6+R8AAAAWElEQVR4XmPABhoulv8L3u/4
b9WDJf8YiAVhh7z+Sa1i+td3rW1Iauq50vAPHVtsUwNrCjnggiEHDhyQJCkY5AoGUNCiY80N
ImAF5luVMeRA0TEsg5wcTQBSzp/Bl+GQagAAAABJRU5ErkJggg=='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 12:13'!
alignCentered
	^ self 
		iconNamed: #alignCentered
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAA4AAAALCAYAAABPhbxiAAAAGElEQVR4XmMAgv9kYsrB4LNp
5PuR5n4EABlNR7k2RqUfAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:05'!
alignJustified
	^ self 
		iconNamed: #alignJustified
		ifAbsentPutFromString:  'iVBORw0KGgoAAAANSUhEUgAAAA4AAAALCAYAAABPhbxiAAAAGElEQVR4XmMAgv9kYsrB4LNp
5PuR5n4EABlNR7k2RqUfAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:06'!
alignLeft
	^ self 
		iconNamed: #alignLeft
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAA4AAAALCAYAAABPhbxiAAAAGklEQVR4XmMAgv9kYvIB7W0g
18aR70ea+xEACGxHuXnIjwsAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:07'!
alignRight
	^ self 
		iconNamed: #alignRight
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAA4AAAALCAYAAABPhbxiAAAAGElEQVR4XmMAgv9kYuoB2ts4
8v04aPwIACouR7mqZRDdAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 6/20/2012 15:33'!
ascendingSort
	^ self 
		iconNamed: #ascendingSort
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKAgMAAADwXCcuAAAADFBMVEX///8AMmUAAAAAAADm
6jUPAAAABHRSTlP//wD//gy7CwAAAC5JREFUeF5jWLVqAcMqrlUMK4JWMSwMWcXQGqrFIMrq
wdCyUJFh0YoVQPlVIAwAJ0EPMMGmV58AAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:07'!
bold
	^ self 
		iconNamed: #bold
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAkAAAAJCAYAAADgkQYQAAAAG0lEQVR4XmMAgv8EMBxgE8QQ
o42iweAmguEEALyZOsbVb8GVAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 11/29/2012 16:44'!
chartIcon
	^ self 
		iconNamed: #chartIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAACUAAAAhCAYAAABeD2IVAAABrElEQVR4XmMY+YAa4NSpU/MH
lYOam5v/nzx58v+gC6mR76iR76iR7ygKQEnFgv9a7lv7B42jtNy3JGi5bTmu5brFgGTNDg4O
VC2n9O3XC2i6bZ0PwiD2gEefhsc2C3DoAENpUKQpoGMqrAI3fNdx26Qx4Ald3n4/B9BBT1NK
Dvyna+7TdN1yA2Q5tvQDii7HiF2RdC0S1N23K2i6b3mLnrVBjrQNXv+frNxFqaNAiVbDbesi
Tfet75FDyzthzw9gKHkMSOEJytrgMgcYUhpumwvWrLnEAROnmYM+fPiAt5wChsZ9UBRqeW2R
AIbWdWg5FAB06PoBqWbAjgE6Cl4OAUMKFGJAx52nWVoi5ChQtCFHEyhNAflPaB5K+Bxl7r9h
L3rpDAyl7VQrIIlxFMgyUPSY+G6+DqT/A6PuIygtDVjTJSb3wBG6pBViQVD6rv9AB7VjK7VH
fssTBm7evDlvsDaHv4McRmO8n2KH/gcCGPvXr18C+OSJ0M9JtRCcM2dOErpYQUEB3LLly5cb
4tMfFxfnTvVo/fr1qyKBehOv/Ldv3+Dyb968+T8kRnsAp2laXWLn3egAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:07'!
chooseDefaultFont
	^ self 
		iconNamed: #chooseDefaultFont
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABIAAAANCAYAAACkTj4ZAAAAk0lEQVR4XmPABjJKOv4DKZxY
TcvoPwM+sO30O7jilXvu/p+z7gyYDTUYDEqbZqLwsYKo1HKYQSgugxpIPADZhiaEYjBZQFJG
ESNsfMNSSTMUFFbYwgeHa/G7GurN//3zd+NzBWGvQ70Bjj0GCsF/Y0tnygyBuoJweiEE0NMT
UaBp4iqURAfjQ1M5aVENDYv/lCRAAHQmc7YGk7XQAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:08'!
chooseSelectionFont
	^ self 
		iconNamed: #chooseSelectionFont
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABIAAAALCAYAAAByF90EAAAAQUlEQVR4XmPAAf4TiQmC/zgM
xqeGtgYxEGEQSeFBskEMHdM3YdNMyGuYlmIxiBivYYqTaRAmGFwGIRmCK7YIpmgAV3xNpMZc
KwUAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 12/16/2010 23:07'!
commit
	^ self 
		iconNamed: #commit
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAKx0lEQVR4Xp1XC1SUZRq2bFt3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'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:30'!
copyIcon
	^ self 
		iconNamed: #copyIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAACZElEQVR4XqWVwY7aMBCGufS1
+hL7LH2APk8Pe9sb0lZ0DxV72ApWCwIEIhGgjQARxZatpJnOeGzHTrIt20X6NLZD5ifMJxjc
Dh/g9nq+fr75MmiD5x4AiKBDKMuyg9YlKKURBcvtDu7uH+FptjFB/xVQ1xBQGyqiqk3Y8GEC
x4uA52XinmZwDT6AGpUVIDVT816XNSi8Phq/YDLA8Szg13x7dYgPoEbcrO6sC6kxYOafKsOQ
8WRJAb+RT31zcfgAoSuQiFA1SGWrrt8jQK8EPiCXVQDuRQUXoeGjEviAc0FUcBZuXcIpbwJi
AbhWdl4qkGBqJYgC6NNkOaHxTQiuqWZn1TyBbeaaGiFIBJoVfrWjR5QAXxTyZCXwAVIqeD1r
ODhOXPenJkCFAmiqlaXGebEE7kUhTgIfsMNmu6OC9MjVrDMJjQTUqGogKawMBc5tNJ7D958z
uEedhw9T+Hb3w9zrA5KjhO2ritgchA8o3PClFUJwLez+ImLyQsQB1GxtkLDeS1OX+ybADd5L
EMhAcpyKUA6yTMcBK2y2SLHpTiBcFzsOYAns8LFmF5YhM+uytS5NpXuigHkqYJYUCNaU6zzh
AC/BqStCB3tOTx0HYPPnLbIRXA1NABmVBhKkWSCDP9d+3Ql42RQwRSbrHCZUzT73AUlGEgRk
Tor2GdMJ6Ps5cG9iCXj4qwNjRAhYWTFYEhEH/ItQgoWRgAXwpPEZrX0ALgz0s/sGVgIrQNKS
wZ2nIrjeExDS+tMwATMnQUeEft4dQDcZAQwkQQ7TNctA+6k9c3L4gPafNNEX8JYEf+PqgI/w
B1P9qGg+UuzcAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:30'!
cubeCell
	^ self 
		iconNamed: #cubeCell
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABsAAAAdCAYAAABbjRdIAAAGe0lEQVR4XpXWfVCU1R4H8LMq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'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:30'!
cubeIcon
	^ self 
		iconNamed: #cubeIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAFTklEQVR4Xp3Ve0xTVxwH8Gpf
VBAmThlsokOj4rD3lqfIoyrKIxMRnQoOacQ3VmD4YIMYQFyEUpRpwMlEZBGHCAIVEBBoWSv4
AEFe5VEsyjQuZjNZsr+/O7cXuxhw6k7yvSfpvf19zjm3PYfzX00wa/p8W2+ezEHGO7M4m98l
/kWIPU0hCKleCq90R/WCOEGlXSg/1XYlT2blxJMyz3PeWdCHJ3M8yCtaVsA3UjV8UDdJKgSg
SoWm5PedQP5QGvIGSfRpyOlLQvIDGQ63R0DWuBqbq9zhp1jU5Z3qpPYId4nnmArGkYLFPCPV
zAXVMh1UPQ+UihSumkglyQ2BCcrpPQbl4BEo9UeQPUDSfxiKPpLeRJzuTULp6Hnc+b0Rz/4e
Q8EdBThMIe14PS4NKJHx8CBi2gIQol7EIrdI6khqeaCZ1PBwsjcWGfoDyBjYj/T+fUjv24f8
4XTUjF9B95/tePCHBqrnP0PRkwhxpjU4/hX2ODP0LYoM2SgxnEOZoQAtT1VQj9egcFiB5EfR
kN3zxZpWB9C3uUjui0ayPgqK4QQUjmahdvwqWp5V4+poHnL13+FodySO9mzD0QcRLLCqeAFS
9NFIG9qFkyP7kWmIQwbpFSMJuGDMQOFYFtQvVLj/UoOG52VofXkTF/Tf48rgORQN5OBUZwIS
27fiUPtGyO9vgLwzFPKu9Th4N3RiBufn4/DgZiQNRSJlJBqpBgI9JpDxEJRjich9moRTY3Kc
HN2PrJF4GP8aQpr2AOTN4eQXFYzd6kDs/nUddunWIqY9ADH31iCmYxV26lazgG+uI2IHgxE3
HIrEkU1IGt2GlMdRSDXGIGNsHzKfyKF8+g1ynyQhvj8MA6+6EKWSIqrWH1/X+2L7bR9sb1mJ
SI03IrVeiGjzROQ9d0S0erKA9+lPsXPQD3uH1iB2OAhxIwQybMIxM7TTBB03yOChE+HhSx02
33DHpmo3hNdIEH6LRnijGBublyNM44Iw7TKEtTljQ/MyFvDKsUfkgCt26FeYoD1maL0ZSiZQ
QKc9aO006F40IKTMGcEVSxBctRjBNYsQVOeEwIbPEdi0AOs08xGodSS9Iwt4KOdiY99SfNW/
fALyMkMHJqAt/WLQdzkmoPG3ckhL5kFa+hmk5Q7wr7KHn8oOfrVz4dswBz5Ns+GrsYWP7iMW
cMv+GEGP5mF9r5MZijBDvojWe8Otg2cGKo1F8Cy2hceVWfAotYF7uTXcK63gprKEa50Irg0W
cGsWwrWVzwKSrFmQdtkioPsTE/RlDwMtIZCLCfJ5OBN0B8cMlIycBV04A3QxSYkI9DUL0BVC
0FUC8kfkg67nQ9LEg0TDZQEq0waenRZYSQqxkJ0ZWt09ly1OQpHiVAMXeT3pHwYwF0nHNLh2
cM2QP4GkXbPZwjpSuJ7sUczGR3KiTQ66wBL05Q8EXoeFhJBoJzY8Ziet5puB49o9k4FyAlQS
4OZ7ADS5QV0nW3OJBahrwknAsdYdUwPMLMiOa5pJLYHq+G8CzAdUsQjUxRmgLoveCiSot04N
3JiYBQOQOmKFNVzSrF9xmAuVbwnqnBWoH0l/UTQZUP0LxDaGvQUgz5UJIT5rZRq5Q6jFGa7F
NBuO3VphqjhzJsRKkp9mvBPYfStoypdMke8yhRfutVSLHLjUpKNyjq8wfnG8VZf4B0uIi0Ts
ETkFsKN21RsAMxhmcMxK2LoJZJx3NQZjpuecYmUUF4rYo5KcZq+BbaoVJoC6RAqftXxzOT60
MVOdt0VU5KK0fEVdF5iOz/AKCcTkfYmzZk69HP+32XzBD2OwdXnO778cpP0DqZY7koDpbL4A
AAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:29'!
deleteIcon
	^ self 
		iconNamed: #deleteIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAB7UlEQVR4Xq1S3UsUcRQ9OV+7
W7sa2Fb64EsYoa5REIGZJPQSBflgkdBiPiRIqUFRFhH0FoaBZoZhRJkFQREJ+if4rP+EoeHs
NDo7+3W6MyrM0q5BeGH4wdx7zrn33ItdjWag9hhQVy5/BIglgHjJZAOQvG8gM6DDbQTOlyCv
79Xw84GBnORvFyXrgepBAWfbm5n68Z6PqkKuEJ7bzgsgcS+qraU+jDLT0cqhEAoNPudWHAVq
ejRsuNWg/eIxzflPvBvV0k3AWSk8NRTTbPP7O1pfJpk7rLJXR0FGOVHUhRS33dKRzhwAf795
RvPbW/aHFedJpe6Ys9O0Pk8we0hhv+GrJ8v50D5gwM3G99D6+JLmzDjNuRla02PMHKygCORF
qGvHTXgG3hE/8qJmjz3l+vBDuvEK9um+eVf+uUpRuDASQZYyyloMNCvBtHhzU4cjc5/eESwj
XBqPIOeBl/eBSyq4qIC/hMgRkm4N9l/mBVrvmNyL/DZ4UcDXVTjPDeQ9Eq8bW0iSGsyEX16s
3DIVAHvKXSo25P8Z+a6Nyt49kpSMYwlJp4rVk0AkqH5xQZIr0U3w1S1wwJcbr8ObJPZ+UC62
4B1fUReXFUx9FfVOBetBcKDLvuEQ+CoMygmOlPRBZmtt9J+yJh8va+L/xh/KgsivEYu13gAA
AABJRU5ErkJggg=='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 6/20/2012 15:33'!
descendingSort
	^ self 
		iconNamed: #descendingSort
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKAgMAAADwXCcuAAAADFBMVEX///8AMmUAAAAAAADm
6jUPAAAABHRSTlP//wD//gy7CwAAAC5JREFUeF5jWLVqARCvYli0YhVDy0ItBlFWD4bWUEWG
hSErGFYErWJYxbUKJA8AOI0PML5ZXv0AAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:33'!
doubleLeftArrows
	^ self 
		iconNamed: #doubleLeftArrows
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAB70lEQVR4XmMYnECxQbZEqUF6
Ai55yXJZd/l6mfUMDgwsGJIKVdKFjmtlX4cdU/qo3CDTjS4vUSbtaDhd9knqLZVfyk2yG1Ak
Zasksq0WSr8qeqfw332T3GulJtksZHnRQklbnX7px4VvFf6HHlf8pNwsNwkuKVUhlWI4Q/Jl
2j2p/45rpd8oNEgWIGsWKhK3UOuQfpxyV+q//36ZLwoNMjPhkmKlEnE6/eIvI8+L/LdaLvVW
vlq2BFmzSJ6ksVKz5KPwMyL/PbdJfgX6fy5Cc55YoEq72Avf/Xz/LReJv5OulKxC1sybKaUu
Wyfx0HsP33/HdaLfZGukF6L4W6xQyk2+SfSZ2w6e/6bzhN5Kl0u3Isvz54grylSJ33PZwvvf
bpXQN+kK6VVAYUYUQ4SLpQIUW0Seee7k/W8yW+ytRJlEPbI8T5akpky1xAP3HXz/bVeKfAWG
1zKM6BPKFQ1Rbhd97r2X77/xbPE3khWSlcjygplieiCveO3m+2+3QvQL0CWLMAwRL5SKUukQ
BYYH/3+j6UBDKlFjQiRH0kSuQeKR7z7+/zYrRD9JVUrNwjBEokA6QaNH7IXFEpEvUtWSGAqE
CqQtFRslHjuuF/otXSm1B2tSFS+SSZUql5qLKymL5ErYS5RJbWHwZGAf+IwHADNZoO8B743U
AAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:34'!
doubleUpArrows
	^ self 
		iconNamed: #doubleUpArrows
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABEAAAAWCAYAAAAmaHdCAAAB0UlEQVR4XuXU7UtTcRjG8d5E
EBQFza0XtUmkRTbzGKbFkRQ1BxYmmNhWS4sIIgWlRfQAkSYs9mJiK5jOh6mbbup2UBSZlQ+z
Qy3bXJayP+abe+MbPah7mb/XFx9uuK/7t2+PvRe+Zkyd1aQMvPJbuCFlUPNNi8mZAvTG/5xS
7ylMyyrqVjVUL2i521mzc6h19DWiK53K+SMUOrIotF/kTlxN1Rcd9d2m7SFr4C35HTpKxg9y
uf0sU7Kf2Ep4HcrFGE2jclrLgx6zMtQ13cGF91ou9e8nz3YGKezdCP+MzyK2C9xeUnF9Qsez
ocatITk6g9Byjpy204zMuTeF5NgMoj0H0XGe0PeA8jRyNEQw7FEMyLEQnyPS7jYViX9lbNGd
ek+Wfs9R5BC41q9naLZr91ByI6JdWO+JmvuJ45T16hlZ6Ns5tPJX5opN4Ob8UQzSCSrGMqlb
01Di0iMteraHVtciFFgFSscPUeTR8LDbTLK9huEMzH/UFDv1TMo+ZSiR+EXeu1wKBg6Q7zrG
PadxI/xy2EK5L3kGaVz9lE3oR3BryBZoJcuqIvvDYYwfN9/J08EGynw6DMGTWLyNytM0uZ9Q
67ilGGgaeMyjnnr+49/vHwk5/gS7dCrsAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 12/16/2010 23:09'!
edit
	^ self 
		iconNamed: #edit
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAADkUlEQVR4XsXXW0iTcRzG8X9G
BJFUFxXURQTVRdFFBEEgQRKdoIvK6MKCoigspUgouslD57roJGtWIkRqp82ymc6p6QgPaV6I
WbOakNMtd948zMN8+r3v3uXcwf6rjQZfBd3ez+N431fGADB6rKD2xLkVICs43xd6AuL8kIzp
B/zoMaDH0AtDbx/6jEYYTSaYfvaj32yG2WKBxWqF1WaDzW6H3eGAg3I6nXC5XHC73RgYGMDg
4CCGhoYwPDwMj8eDkZERcYDyKntqe5Yo78tePyfigHjgo6OjcOuyYa1lGGidC492u9GauW51
2AHxwB2dF2Cp8eET5kzAlIxB1WKj/52YMiDWuP2ThLdM4uNf5sH8guHb1cT8kAExxTuzRNwd
iOt8+JdbDO9yWFbIgJji1WHwlwy6O5N4yIDY4NkwC/iHqbhFwfD1LkNtNrsQ8SqICa7x4d7+
AFzJ8P1eKB4y4N/wHB/ePIl7BbyUoTuP4fYhVvLHG9Hfn+0+3BWId82DlfAfMob3Rcf47oR/
i/dXhcFfMfTcp7e98DCam5v5BkSP5/rwpiD8NeFyBs2jg9BqtWhra+MbEDWuDsVtZYTnM1Tm
p0Kj0aCxsRHt7e18A/hPuIsi7mwMwt8wGAgvl+2HSqVCXV0dWlpa0N3dzTeA7y8Pg3+V8AcM
r++mQKFQQK1Wo6GhASa6u3L/O/4zfgk/K0Nxu4rwhwyKW7tRXFyMsrIytLa2iscYGxvjHzAd
3vvxBowVCXA2BOHlDL2PGJ7f3IXCwkIolUro9XpMTEyIuHA87gGRcKGaguP4/nbzVPwt4QUM
xdd2Qi6Xo6qqSnwXA3EL3V25B0TCXTYj2kvPoUudhc+VJ0XcUeHDn1zZBplMho6ODhEOxq10
d+UeEA4X0jUpYKi/Bn31ZXxUnEfH8yQYChII346SkhLx6omE2+nmxj0gHC4c8GxGKmqfEKzK
RT19L807gaLr+8QbjB+OhAvjuAeEw4XOpB9A+tG9ePX4JrS1ldDpdOIly4ML5wT3gHC40Pj4
uJjX6/0dLx7VVRAPXDivohoQa9z/uYBrQDzwqO6E8cCF13IP+J+fDf2fjlOo/VQqdZA6TB2h
jlFp1EkqgzoldTog/88ypOelSa87Ih1nHTWXmk0lBA+YQc2Ufik8aQG1iFpKLadWUWup9dRG
ahO1hdohtZVKppKoDRK2hlpJLaOWUAup+dQcapZ/xC/aEUk2F9wUZAAAAABJRU5ErkJggg=='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:34'!
filterIcon
	^ self 
		iconNamed: #filterIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAADb0lEQVR4XrXVa0iTURgH8KPz
ktYyL6iYy8gwuyipEGUX96EP3YXuFz/0oZGpM7UbmEqmIaQhCiVZJMRmpGgSUkGOFiuY2Gji
ookbjne1DddG79rWZMt/Z9KiaNGs9cIDh/d9z//3nPe8Ly8BQPAf6/tAV0IWMGfCKvSXuSqm
JcE42Rz3YaI51q1tS8JkZxqMvXlgnxdi+m0pYKgH3tXBrS6DQ37IbRnINxtupb/XN8YomCpO
qTfLH9BlGywAK9sN44N1ULelYriaC9m5hXgkTEZf6XL0Ctfg4dlVkNZmQN7Ag/JKMtQdq8Dc
Xw8DbUBzPQWauih4s/wB15jKUEx1LIVJnA1NOw+KWi5eUODZhVT0CzMgEmSipyQDQ+fTKLwI
w3XxULUsAXM3B6buXBhak0FX4AWu+QM4ulOkWHuSuPRVoTBcmgdTazwsXelgBzbAId0F5/BB
OF8dhv1lISyP+TD15MLYtQIm2pS5PRXM+SgLBYp0pYTzC+CriePklPUygad7HtjeFLBD+bCP
CgBrJ2gKoK+G9dlWjNG9kV+KgqKRC+dgHr28HHTuJjg0/jf5x9KXE9l09yI4JTmze8IqyzBj
vg4YmwBNMcw0UHnV+4gioe1IoUABdMLw+7PhgQC0k7XWthiPR7ET7MhxClTAzTTS7i9gZmw/
DPfSoWiIxqv6aLrKLFjal9rpnMUBA08EhGiLQ244JTvg0tRRoBwOVRnt/iTcw3z62iZipDYC
b1oS4OjfCG1JePn38EAB2lGcqS3d4p5sgG1UCFZ+BFDtg0uSjfFW7ixgFmXC1Jw2Tu/lzBn4
hhy1Pd4L1/gZ+pFth0e+BbaBJVA1RULZwAUryqXdR/B/Cp8L4C19TaxseuQo7FI+XE9XwyqO
g7I+DPqby2Bo5A3+Ej5XYHbDuzI9bul62PpSYOqMxmv69phvZ33WCEJT/xnwlkYQcsMu4sEm
ioWuJQwTVxPB1CQ1+Q3/G4CuImasiHzUV4d9eV3BmVFXJznouYigAd56yicWW2cOZqyDGBOQ
qd+GBwL4q0cFRO0D5MfImzn/D/5U/ZuJxAcM7SWSoAPijeSmDxjYRsRBB+7kk9M+gI4vBh2o
XEkO+YCLWeRE0AHefLLHB+TFk6KgA/Q4MFqz7JND1+3hhJAj/wNIpqsoSYgkYu840HlfAcR1
DQHkXkQMAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'private' stamp: 'cmm 12/17/2010 16:39'!
iconNamed: selectorSymbol ifAbsentPutFromBytes: aReadStream 
	^ SketchMorph withForm: (forms 
			at: selectorSymbol
			ifAbsent: 
				[ self 
					iconNamed: selectorSymbol
					put: (Form fromBinaryStream: aReadStream) ]) deepCopy! !

!MauiIconSet methodsFor: 'private' stamp: 'cmm 10/27/2007 13:22'!
iconNamed: selectorSymbol ifAbsentPutFromString: aString 
	^ self 
		iconNamed: selectorSymbol
		ifAbsentPutFromBytes: (Base64MimeConverter mimeDecodeToBytes: aString readStream)! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 4/17/2008 10:52'!
iconNamed: iconSymbol put: aForm 
	^ forms 
		at: iconSymbol
		put: aForm! !

!MauiIconSet methodsFor: 'initialize' stamp: 'cmm 10/7/2007 20:33'!
initialize
	super initialize.
	forms := Dictionary new! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:08'!
italicize
	^ self 
		iconNamed: #italicize
		ifAbsentPutFromString:  'iVBORw0KGgoAAAANSUhEUgAAAAkAAAAJCAYAAADgkQYQAAAAJklEQVR4XmPAAv5jwVgBWLKl
pQW7gurqaoImwE2BKh7UpvwnFDYAfqYqEyKEJ1kAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:11'!
makeNormal
	^ self 
		iconNamed: #makeNormal
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAkAAAAJCAYAAADgkQYQAAAAKklEQVR4XmNgYGD8D8HoACYO
l8OnEIODrpB8RfjYOE2gXBGGjzHCA0MzAPyIHgFB9iybAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:34'!
movieIcon
	^ self 
		iconNamed: #movieIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABcAAAAYCAYAAAARfGZ1AAAABHNCSVQFBQUBSsjp7wAAAcxJ
REFUeF7FlaGSgzAQhpHIyMjIyMjIyMhIJDIyMjISGYlEIisrT1beI1RW3hvsJQEKLaEw185c
ZnbYQvi6WfbfLf5laW3A+Q6sbcA1PdgNm54Z66HxwXceDsAtuO4MXGmo+5/BTqNlfnNlof26
gtLNMbgMYEL4DFyCn+AswBEiUJb4CNyBv9xA1vYRfsqfgKlhfybyEvKGsvcj6BnOJ7jxR+Hl
BtyCbr/BdhcQwVemTzkvUkrQe/BoQkjAGCefCp3+UNYNUK4+D4+RfyQtW/D48SmXH4BzsYIL
WQOh/D04QjgT+Vi6z6VYlvEFBPG6BYziQIgmk6YD3d/ABasqC5XtX9X5/gnisVcK7WZBpVK8
799ZGJP75spf1pJfqnRUaBsir8xOb2GMJSghwxVhCnV73ZT+g/zNi65IKcumhRAKpr+uI190
xViKjAnYjDhWQkpFbZLiCFNQaT+egIU839adcQGnTObhsWJSaYXodcjd0BWHJsWkTs+UO2fh
u2nhnANJH7IojBkiISGS6fhV87WCzjkP+3VWoetlwpijVKQBsDmFHlpuHC51eIcfgBt3T0sU
TLQImnyd/GDd4M+N68CYY4zDX3rOIRF9Yv0CAI7oz3CEU4QAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:35'!
newDocumentIcon
	^ self 
		iconNamed: #newDocumentIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABoAAAAWCAYAAADeiIy1AAABf0lEQVR4XmMAAauANGWbgAwH
amJ731RToNGMDDDgHJ5f19Gz+N/iWev/928/9797x5n/k7edJwt37jz9f+K2c/87dpz6XzF9
/X87/8wTcIuyWue9ee3k+X/vvf//m85f/p92ZN//7U///t/17D9JeMX9j/9TDu/5337xBpie
e+vF//jyCf81TN18gdawMriGF35Y1rvw/76euf+nn7j9v/f41f+LTj4iGS84+fB/5/HL/2ed
vAumOzcc/+8YnPNfXtO0FmiRDYOtX/qHzLKu/+u3Hfi/bc8xquCNOw79z6/p+w80G2aRL4NT
cPaHj5+//P/+fy9V8c+fv/77xZYgLApLrf5EbUtgOK+qd+RbNPItGvkWkYn/f2eAY5pZhGwJ
DIMt8o4u+vj371+aWQK3zMYv7c685Zv/f//xk+oWTZkyBWGRlXdClo1v2g9QSUspRrcExSIg
4OLk5osSkVTIoAbGGUfQet0diIOohdEsAYmZwWp0ZiAWAWJRGmBBkAUAx4Ad+Vy9w0QAAAAA
SUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:35'!
outputIcon
	^ self 
		iconNamed: #outputIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAGDElEQVR4XpXVe1CU1xnH8U1F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'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:36'!
pauseIcon
	^ self 
		iconNamed: #pauseIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAkAAAAKCAYAAABmBXS+AAAAG0lEQVR4XmPg4OD4zwHFDEiA
A1mcY+QropoiAO6SQWWazH6SAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:09'!
plainFolderIcon
	^ self 
		iconNamed: #plainFolderIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAAC0klEQVQ4jaWTW0xTdwCHv3P+/9NLegWhpV3n
hYvchIoWcAwjRKkm6oYmW4xvY1my12U+7XG6x/mqZpkONZkgmsUlbtrFZRrxgkXxFhCNupFW
RBARCj2n7fFBlxhN1MRf8r1+T98P3nPK1xHqAM9chkLAyOaIHbjKzLsKZM5k78Lq6qVCSiJt
bdyKx3WXo/dE1kj3qGl+33WNx28SiIb5ovWHA98tWRbdzOClK0ipio7t28sDi4o3zaSmtxWL
0eZIAEdjiJG+BNOvCeqKzLKWaGi1i/NUNDaTSju4eWo/a9sr+fiT9WpT+9YSZ37BhsmxR98u
tk1GlwfJqy3i9pUHpABEJIinakX91kK/Feb+JRjexPHOozQ0+1D1u9jNIcqq/bR8/plS19b+
ocVmjyZuDX4V9uX+6E8yKhpDzOUF5n9TEV4Ewo4i3di9Czi4s4vZWYUPihcgpQGz93BbR6iu
LyO4pM0Wj8UC8SRdoi/BVG0hHSs3rvIgrJB5QqC4lBWfbiE1I+k9cZnL5+4gLE58oQBkpymq
XM2RPZ3mwANHtwS4f3Owe+qpdZvb6wQzA3oSaf5HOJJPuKmDnPRzsvMXMrmHhD8qB9NAk5oF
MhUqQNbk2NULQyC9L5EHigR9DDV1nXVffEnf6SHQ5oFpIjSpAZoK8KSE3uOd3Y91Q4JwgXA/
R3qeI5xgjFPVtIp7w49AEQihakBWBTh8mOx4MvHjoZ0/kdYFCMcLnC+ELjANGqJruH7hBiga
miYlKGnxfxDxBGd8U8Pjf/f8tnJu1rB6/UFc+QWgCFA0UDVUoTAxNkmobDF//XpIP3fH2Cte
riqe5OIyt757oH/g9smuo5mLf8byJkbHnKq04S4oQmoWPAU+UFT+OdKTPTts7FHedpaWhZYK
ry2z3m5TW6tqKuvLl9b4gqWl7Pt+x8jPca31rYJX5qj1azXzbNmmkafy/vCEHnsGoAD3o8FK
4poAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:36'!
playIcon
	^ self 
		iconNamed: #playIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAYAAAALCAYAAABcUvyWAAAAL0lEQVR4XmPg4OD4z4ANcAAl
OLBJwiQwJJElUCTRJeCS2CTAkkTrIN5VWP2BzeMAeYInPbXxuu8AAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 12/16/2010 23:08'!
refresh
	^ self 
		iconNamed: #refresh
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAJh0lEQVR4XrWWCVRTVxrHRWtd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'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:37'!
replaceIcon
	^ self 
		iconNamed: #replaceIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACCUlEQVR4XmP4//8/w38smNeG
nR2Ik4HYH4gl/+NQh0uzpXqO3FPv2Q7/k5dG/VdOkv4EFLMnygAeWzY/uXqBfxorxf4rzxD6
rzJb5L//Lsf/GuXyP4CGOAGxEhAz4TRAOJTrofJMof9ybQL/+b04Lklk83xWnCj432CN3H+h
YK7/ggGc//ns2WZhNWCDpCCvkDXrRtFk7o9AW7Kh3tEUT+f5ozJX5L/ZZtX/CYeD/gu4cy7H
boCEwK6NEgI3gQaxQjVzCvhy3JHvFvivuUb8v9023f8he9z+A8WbMQwAaoreIs7/ZrcI7zsg
uxpqgKREFs8HpcmC/zWABhhuVPiv0icGMsABxQCgBmGg7W/usLH8eMzC9B/I/goUU4Uaoioc
xvlGvkPgv9pi0f8iMdynMGIBqHj+QUGeh2+BXBA+zcv5CmjIfqRoFeKx5pzE58Z3lt3MMpZB
v5wbbgBQswoQ/98ixv9umxj/KyB+DcQgb/wHYjewIoOKqUBNv4H4PxT/YTSoWAOkmWAu0AZi
AzSsD8RsQEX2IE0Gyev/e9Sc/u9Ze+a/acZWkCH/gDiSAVcShTtRvzwAZEBQ+7X/oV234JjZ
qBrkogy6GOAHMsC9+hRcs0/jhf/AMPgLFE8jxgB2RoPKyyBDOC0af3BaNv0A+R9owBMgLUjQ
AKghPEDsCcTVQFwLdZUgSA4AOdAY+X97s4AAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:37'!
rightArrow
	^ self 
		iconNamed: #rightArrow
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAgAAAAQCAYAAAArij59AAAA/ElEQVR4XmOgAvBkYJeukt4i
UShhj1VeqlJqj9dusd8a3dKPxQqkLTEUSJZLzrJdKfop5rLYf/VuqUcihZImmIoqJBc5rRX/
EndV/L96h/RDwXwZPWyKlrluEv8af03iv1q79APhLElNdDWM0hXSq7x2SnxLuCH5X61N5h5/
jrgiigrpKsmFzhtFv8VeBlkl9VAkX0odLilRLjHXYpHQ14DDgv+VW4GOzZM0hkuKFYvP1JvG
98V5M/d/pUaJx0JF4hZwSdEi8UmqnZyfzBaz/perF30sWihpi2KvSKH4BrUetl/SVcJPRPIk
HDGD0oGBRaRAfL1Qjpg7A00AAPp3TtHlfEoZAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:10'!
rightArrowIcon
	^ self 
		iconNamed: #rightArrowIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABHNCSVQICAgIfAhkiAAAABF0
RVh0U29mdHdhcmUAU29kaXBvZGmU4xfQAAABr0lEQVQ4jb3ST0uUcRTF8c/jPDPqlKORiqSt
JqSNRfM0LlqElkRtItAIa9HWF9DKXkCbIAQhIohoURQFtQ2iYDYZkpAEUS1CamOBjppmOvNr
MZRUi/5And2F+z33cO/ln6tXt6KBv4N365SYkwgKbivq+LElAnv1YUjQLrIkWEAdBrVkthnt
YfwFMx/nRM6YdGXDomifxIrBzcFwLjiaDQ5mgr500J8OxvIhE46FsfV7IR7vDopRkLjsuFQt
QeKiVDTSUhpyMtOvS6u02IJlT7z0yLRVaw7YZacu1x/eND9aYq161ycnIokJjalepSPqpW3X
ql7arLL3yj+tpV2z2TvPODcN52ORipUKryasVta9DlWiOuI0cYaGJjry3wxmlcnHtSJoigVv
wbs1mpdRJVQIYWNsNkeujdVl3jzn0nzNK3Y2kjiNq9/lbEixNaYjxUgjqSWyLSx+oJTl2mJZ
1YApk7UzJgqCHeo0qKqIfBZ0ilxwagv750ilub+JW/OLgkOeevzrR0pM6Y2CG7lguD5IzEgU
fg1+VcFhiRWJIPHAHm2/D2+kyEv0/Dn4v/QF8kyGaRoL4uEAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:37'!
searchIcon
	^ self 
		iconNamed: #searchIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAFLElEQVR4XpWUe0xTZxjG6Q0s
QmHchFamJiZkgLIMw1hmBrKgLuqS/bEQN+PUIDiUbDDrlgzImBi5fOMWVkJpLEWBAUGIVKtp
F2AVS20JdGCoKR26NeBKBCEtUlv67j0tKF5W8UuenJz2/X7Pc97vPccLALzgDSQQCPZWVVX9
VlZWpi+vqICfCwsf5eXlKc+cOVOQm5sb/mL9msEiUf1WgaD2Vnt7OxiNxvm5uXmn2TwNxnv/
gG7kzkJXV7c1Pz/fcvJkFv+NDUQi0bv1QuFDjUYzh/dgfmAe7enpkTU3N1/suNzRohoY6NON
jv17U6VxVFRWQmZmpnjNBhdEF4Lq6upMev1dy8LCglWhUFxFQ6LVDpKRkRGi1+tRYwRrKtQa
7a2+fjWUEWLPyMj4YU0GQqHwF6m0e2nKPP1YIpGIlX19REeB7+qJccJITCYTwVaR2dlZIpVK
0XhooEepsuXk5FjQhPcaeH2AUFi3MDw69rhfNSDv7r7iSjwxMeEGT7vBFquV2BYXicPhIK2t
rRXaQd3DS03N82jwo+eJqa3d19bWDv3qoSc4OZXPEptdYKvFQhYXbS4wOIHgHoJtJJrBoT+U
A+pHaKD1aFBdXfVN1xUpKAc0+urqahd4bjnxog3BzmdgSk5wErvdQeRyedvg8Ch12GaPBhXl
5fyOzivQq+y/3dDQQCxUYpu7FStQtxDssGN6K5mZmSGdnZ0X7+gNkJ2dbfNoUFJaeqSltR2u
3ejR45Qst8K5KjG4ElutbvDk5CQxGAzkmkx22Xjvbwe26L5Hg3NF56LFYgmImzrsDRJJ5epW
OOz2F8DjRKfTkcZGCRkb0yuHdTrqkJteO6ZFRUXDdeLmpd6+mxfrhfXPg00IHje4wP2qfnL9
+nVSUlJSMzc/b8GWAhp89lqDtLS0YykpqbBnz17n+fPFtTU1Na4xNYy7E6tUKiJXKIjgVwHh
8/nkwdSUFofBnpWVdfulF41adDr9qd6OjNyy/8CB+5kZxyF5Vwpsj4tbkit+Ly0uLiZnz56l
0rquFLi8vLxyZnZ2xG63L+Fvc5h+q0eDjTxeFMJNp09/B4cOfQlxcdshODgYzpVWQZdU9tc1
2Q0FTkv1Dbm8Y3BoeNg8/dCGL6ETv6yTCE945bdoxSAiIjw6dXfqVHr6cTh29Ajs3PkhREZG
UgZXcbLGxY0t0NElA3nvTVAP6gDfcmi8dOnJiRMnahAe9L9fU2ohZGti4gemgoI8PKRMSE5O
gs1bNoPPOraMxWIxqDqEbMlwr1PL109R7Fed4XM3oaEhvPj4+PsZ2PP0Y0fh45RdEBUVBev9
1v/p7e0dxOVy6WFhYbTVewIDA2kcDofm5+dH82gQHBISGh0TY/iez4ecnG9h955PIDY2BnCj
2dubtdHf358VweV6b9q0iYntovN4PNqGDRvoaMDw9fVlsNlsOl5pWEeZeeHTetFoNLeBP4fD
xqTqr7NOAZ9/mhpJiI15BwIDOAtYmICFTAaDwVnHZr+FAN+AgAAWgpmYnMn29WXh0zGxjo6i
MZlML0rUWT41wCQiqi0FBfnwxcGD8N6OHRAUFAxY+DkeCwu1HhWECkD50Oh0Bv7HQCqDAuOV
jgFoFHRlrUyjyyAp6aOpwp8K4fBXhyExMQF4PC7gpnysC0Vxl+HrqH1UKqS5UmJ0t7Adz6V+
2SBJum//Pkh4PwHCI7iAj9yENRGoMBRn+SlcOykApnVB12ywbVvsTjw8dUhIiNbHx6cd/+ct
p2dTtV6r1psa/AcrsN6PajArwAAAAABJRU5ErkJggg=='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:10'!
setSelectionColor
	^ self 
		iconNamed: #setSelectionColor
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAPCAYAAADtc08vAAAAeUlEQVR4XsWQ4QrAIAiEfW//
+t5X2jQZhQWDCYeOdV+X1AuH2hYW3yjOfAugAwD9A2BmVCoBfQiZAQhdA0TkHqAmlUf22fvK
GNJDSHdaAu7/hKzvEkTZExLADI9Z+xEgP2E1l4C0Q4ylzlBlgnHDBNhObgB58+/te29p8f8o
QcwbOwAAAABJRU5ErkJggg=='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:24'!
smallTrashIcon
	^ self 
		iconNamed: #smallTrashIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACeUlEQVR4XmPAARjl5aWs5GVl
S4C4VUlKSo6BGCArK6sjLyszxdFG72VXQ/j/C/tr/u9cU/Q/O9ntj4aq0lI5OTltrBqlpKS4
5GWll3u7mfzbvjL//5VNqf8PT3D835Go+f9Qp/n/jb2e/++fbfrfXhP6T1tdeZucnJQ1qs3S
0lXLe4P+v73Z/f/ixtT/9XFa/7nZmf8Dpf7zcrL8Lw5Q+L+61vz/6ytt/19e7/mfleT6X1ZW
KhxugKS4eOvlBX7/j01w+L97btT/J5fa/8+fmvE/0N/tf3yM5/9DWyr+P7zQ/v/eubb/H+9P
+L9iTsZ/SQmx6XAD+Pn5XRTl5D6HBEf8v7Ag4P/56c7/7+7M/P/v1bT/359O+f/yRg+YPry1
6n9FbeF/PW2Vz/z8vGnIvuAAeuO2sl7Qf1XDsP+u3nH/D04P+f/pSsP/1Usr/6eW1v0PL576
P7135/+E9q3/JcXFlgH1yKCGg5TkaZ+4zv8+0W3/7X3L/hvYJP13CK/5H1qx/H90x97/UT1H
/0f0HP/vkTfzv6iocBtGTEhLSe7yiesCGwDHuXP+hwM1IWOHuMb/IoKCGVgMkFjpFdeBYkBA
6XIMAyz8M/7z8fF5YqYFCYlpHjEtKAYEla3EMMDQKeQfGxubJoYBwKhsdousQzHAP38ehgE6
lu6fQPZhGCAkJORuYhf8FxaQIOyVMQVFc0j7/v9Katq3gcoFsaVoFkE+vkhVNZ0nMK+4JXdD
NLbtAweehoHFH2AMTASpxZmhODk55SQlJNbYBeT/sw8r/2/qEfdfSUn5k4S4+EouLi5Q4AkQ
kzFZREWFkoEGrRUXFW1hZ2dXwWUrAIEYV3X9lPvLAAAAAElFTkSuQmCC'! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 4/4/2013 17:59'!
stopIcon
	^ self 
		iconNamed: #stopIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAKElEQVR4XmMQEBD4L0AEZoAx
ODg4iFeITzGGQlyK6aCQer4mOhwJYQD64HT1PTP9SwAAAABJRU5ErkJggg=='! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 10/27/2007 13:11'!
underline
	^ self 
		iconNamed: #underline
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAAAkAAAALCAYAAACtWacbAAAAKUlEQVR4XmMAgv9omAGHGCoH
l9jQVlRdXQ0WhNLYNGKEDYYCguA/IQwA7TU2rx/VoxcAAAAASUVORK5CYII='! !

!MauiIconSet methodsFor: 'copying' stamp: 'cmm 4/13/2008 17:17'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	forms := forms veryDeepCopyWith: aDeepCopier! !

!MauiIconSet methodsFor: 'icons' stamp: 'cmm 2/8/2013 14:38'!
worldIcon
	^ self 
		iconNamed: #worldIcon
		ifAbsentPutFromString: 'iVBORw0KGgoAAAANSUhEUgAAABgAAAAYCAYAAADgdz34AAAFC0lEQVR4Xo1WfUxbVRQfGxO/
tkzxYxE3h0ucToWNwdxmdBI3YW6yqShxU4dLZEYXvzIj+/hDF02mGNwM0bAQJoSP0IaWQANU
aGABAoQ1pQFSCDRt4KVt2rQdpW3a9MnPcy4tARyEl5zc+9679/c7X/ecuwbAGiwjcSkVSSTn
4nZVtsbvqdKvz6iWWdalVenjUitaxD9agxUwlgPeTFK6bk+VvOlQPZ480YRt72qQnNss5Kl3
NNh5Sostb2uwMVMpr99bU8Z7VkVAC7NJu5kNBxVIyW/DyZ/1KFJMQHHLhjNFBpwvHcGFMhN0
g274ghF4/RF0Gj3YcqIpwHtXJKAFXxE4HjqkQsbZDnxaPIiSRguMZh9CkVnIMuYfeXYWCx+z
IyD2McZdCehHDomcmKXCdbUFNncIDk8I/qCM1T4T9gA2H2v8l7EWEUSDeWdtWhWePdWKIqUZ
k86g2CQRkT80R7JE6bs+VToJ5IU7seDHCEpJOGDIKOjAWxf78Ld2Svi5oNiIziEPplwhWEiC
7KolRPKCDz0jHtzzUg27qlQQ0GQru+ZSuYk0nEXLgBPHLvYi78oA1D125P9igJ1cNTIVgGrA
hTARRORZAcpjhN4DZCGP4fAs+kwePPiqgglkxmaCQsoABGmRn7LC4Q2hsdeB45f7cPqqHhZH
kEBlOKdDGLcFEArLYm0wFJkfA7TPH4hg2h+ieRhf/DHEBCyFTKA7+7sRLm8QLk8QHgKaptRj
rY5e6BWAHl8YZgIPEJhPAIXhpW9eApz2hcQeJ1lpdwbgcAeh7rbHCP5hAolT0SL5hEzZ/bA5
/EKjzK+74CSLmPjI972o67TB5ppTwk3fHe4AbE4WPybtPpgnpyHR/Nu/hmMEEhOESxosGLN6
YRxzYdTsFXM3WbSXzkL3iJvSNUBnwYt60izvym3k/tgPncEFiXLfLE0TuB/FyglYSUFVl4S1
uytjBGFBsOE1JdRdNvQZbRgYcsJgcsJq8+H5j7R48XSb8DFrXUenOaNAh9T8dqTT2K53ksU+
ofG9B2pxrmRIrH0ip3ERgcQvB7/sQo/BjtbuSXT2Sxgw2mGy+kTtefq9Zmx/f05i9Yhr05+N
VmiJhBWMT6/m/BcZ+Ei2GlQg512kYwLO/75BO2qbx6Bqm4BGZyEiG3qHXKhol/DYmw1CHj3C
okZilhr7Puug+jQ4l/eplYKEqq34xxbFglzIBAn7aqDplnBTZcINxTAqG0fRcssK/agbuT/0
i0O4kTTlIvjAKwrc93IdEvbX0rsS99OcAdlSdl06KRuNg0jT5OihwPX6CZTVD+NahQHlRHRN
OU5az2nDwkqwtqwlz7lubcvViPKddLxJjIfPd2PT6/Wxg5a8qFT8VD2GioZRXL0xICzYfaZ9
LlipFcIF7FdqNkh8Q4XnqB+88LEWOz/UYscHrdie1zJPxNbOl4oFxW6GfaftncJv5XrUtYzj
8s3ReQI2mV3EbmBgzqRdn7SLkTNNEJ1sRTL9p7Uzi4rdgnKNnEt96NLbUKm14uHDKmR/14P8
Xw0icFxSniFtYwRsIQsTcXNikoT9otDlrNhwsgj0wOedoFaIzG+6xEZBQC0yRsCgDJ4WJWHt
OejLNpwllsywS+IpmBxcdg2n5lby8Q5B0CYIGJzdw6kbdUvOaps+x4QbucxNiDOGSR4/2iCs
4EsAg3K6ErAcXZu06lvF/64tKeKKcjt6/BGdr+ra8h8KxA4HdGs9dAAAAABJRU5ErkJggg=='! !

MaObject subclass: #MauiPage
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Domain'!

!MauiPage class methodsFor: 'create' stamp: 'cmm 4/19/2009 16:35'!
new
	"Create a new page."
	^ super new! !

!MauiPage class methodsFor: 'create' stamp: 'cmm 11/19/2007 14:34'!
streamContents: aBlock 
	^ self text: (Text streamContents: aBlock)! !

!MauiPage class methodsFor: 'create' stamp: 'cmm 11/19/2007 14:12'!
text: aText 
	^ self new
		text: aText asText ;
		yourself! !

!MauiPage methodsFor: 'access' stamp: 'cmm 6/5/2012 22:05'!
embeddedMauiMorphs
self maMarked: 'delete'.
	^ text 
		ifNil: [ Array empty ]
		ifNotNil: [ text embeddedMorphs select: [ : each | each isMauiMorph ] ]! !

!MauiPage methodsFor: 'access' stamp: 'cmm 4/1/2008 23:12'!
embeddedMorphs
	^ text embeddedMorphs! !

!MauiPage methodsFor: 'access' stamp: 'cmm 6/18/2011 15:07'!
maContextKeywordsDo: aBlock
	self subStrings do: aBlock! !

!MauiPage methodsFor: 'access' stamp: 'cmm 6/18/2011 15:09'!
string
	^ text ifNil: [ String empty ] ifNotNil: [ text string ]! !

!MauiPage methodsFor: 'access' stamp: 'cmm 11/19/2007 21:17'!
subStrings
	^ self string subStrings! !

!MauiPage methodsFor: 'access' stamp: 'cmm 11/19/2007 20:56'!
text
	^ text! !

!MauiPage methodsFor: 'initialize' stamp: 'cmm 10/26/2007 13:33'!
text: aText
	text := aText! !

!MauiPage methodsFor: 'access' stamp: 'cmm 12/20/2007 23:18'!
textStream
	^ TextStream with: self text! !

!MauiPage methodsFor: 'access' stamp: 'cmm 12/21/2007 00:21'!
textStreamDo: oneArgBlock 
	"Value oneArgBlock with a textStream that will then replace my 'text' contents."
	| modifiedTextStream |
	modifiedTextStream := oneArgBlock value: self textStream.
	self text: modifiedTextStream contents! !

!MauiPage methodsFor: 'copying' stamp: 'cmm 10/30/2007 12:15'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	text := text veryDeepCopyWith: aDeepCopier! !

!Object class methodsFor: '*ma-core' stamp: 'cmm 10/9/2013 14:57'!
exportLinuxScripts
	self exportLinuxScriptsTo: FileDirectory default! !

!Object class methodsFor: '*ma-core' stamp: 'cmm 10/9/2013 16:13'!
exportLinuxScriptsTo: aFileDirectory 
	(self class methodsInCategory: 'linux-scripts') do:
		[ : eachSelector | | eachPair |
		eachPair := self perform: eachSelector.
		aFileDirectory
			
			fileNamed: eachSelector
			do:
				[ : stream | stream
					 truncate: 0 ;
					 lineEndConvention: #lf ;
					 nextPutAll: eachPair key ] ;
			
			fileNamed: eachSelector , '.st'
			do:
				[ : stream | stream
					 truncate: 0 ;
					 lineEndConvention: #lf ;
					 nextPutAll: eachPair value sourceString ] ]! !

!Object class methodsFor: '*ma-core' stamp: 'cmm 4/21/2009 18:13'!
registerSelfAsFileReader
	(FileServices registeredFileReaderClasses includes: self) ifFalse: [ FileServices registerFileReader: self ]! !

!Object methodsFor: '*ma-core' stamp: 'cmm 12/30/2007 18:41'!
copyAttributes: anArray from: sourceObject

	anArray do:
		[ :each |
		self
			instVarNamed: each asString
			put: (sourceObject instVarNamed: each) copy ]! !

!Object methodsFor: '*ma-core' stamp: 'cmm 10/9/2012 20:29'!
differencesWith: anObject 
	^ self
		differencesWith: anObject
		using: #=! !

!Object methodsFor: '*ma-core' stamp: 'cmm 3/27/2013 21:43'!
differencesWith: anObject using: comparisonOperator 
	| differences c1 c2 |
	differences := OrderedCollection new.
	self == anObject ifTrue: [ ^ differences ].
	c1 := self maOriginalClass.
	c2 := anObject maOriginalClass.
	c1 instSpec = c2 instSpec ifFalse:
		[ differences add:
			'class' ->
				(Array
					with: c1
					with: c2) ].
	(c1 isBytes and: [ self ~= anObject ]) ifTrue:
		[ differences add:
			'byte-content' ->
				(Array
					with: self
					with: anObject) ].
	(c1 isWords and:
		[ c1 isPointers not and: [ self ~= anObject ] ]) ifTrue:
		[ differences add:
			'word-content' ->
				(Array
					with: self
					with: anObject) ].
	(c1 allInstVarNames intersection: c2 allInstVarNames) do:
		[ : each | | my his | ((my := (self instVarNamed: each) yourself)
			perform: comparisonOperator
			with: (his := (anObject instVarNamed: each) yourself)) ifFalse:
			[ differences add:
				each ->
					(Array
						with: my
						with: his) ] ].
	(c1 allInstVarNames difference: c2 allInstVarNames) do:
		[ : each | differences add:
			each ->
				(Array
					with: (self instVarNamed: each) yourself
					with: 'no inst var named ' , each) ].
	(c2 allInstVarNames difference: c1 allInstVarNames) do:
		[ : each | differences add:
			each ->
				(Array
					with: 'no inst var named ' , each
					with: (anObject instVarNamed: each) yourself) ].
	1
		to: (self basicSize max: anObject basicSize)
		do:
			[ : index | index > self basicSize
				ifTrue:
					[ differences add:
						index ->
							(Array
								with: 'no reference at index ' , index asString
								with: (anObject basicAt: index) yourself) ]
				ifFalse:
					[ index > anObject basicSize
						ifTrue:
							[ differences add:
								index ->
									(Array
										with: (anObject basicAt: index) yourself
										with: 'no reference at index ' , index asString) ]
						ifFalse:
							[ ((self basicAt: index) yourself
								perform: comparisonOperator
								with: (anObject basicAt: index) yourself) ifFalse:
								[ differences add:
									index ->
										(Array
											with: (self basicAt: index) yourself
											with: (anObject basicAt: index) yourself) ] ] ] ].
	^ differences! !

!Object methodsFor: '*ma-core' stamp: 'cmm 10/9/2012 18:20'!
identityDifferencesWith: anObject 
	^ self
		differencesWith: anObject
		using: #==! !

!Object methodsFor: '*ma-core' stamp: 'cmm 5/15/2011 12:50'!
isEmptyOrNil
	^ false! !

!Object methodsFor: '*ma-core' stamp: 'cmm 11/15/2009 15:24'!
isInMagma
	^ (self respondsTo: #magmaSession) and: [ self magmaSession notNil ]! !

!Object methodsFor: '*ma-core' stamp: 'cmm 8/21/2004 15:53'!
maAbbreviatedString
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  The normal one provides type-information, the abbreviation provides the identifier.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"

	^ String streamContents: [ : stream | self maPrintAbbreviatedOn: stream ]! !

!Object methodsFor: '*ma-core' stamp: 'cmm 2/15/2002 00:02'!
maIsException

	^false
! !

!Object methodsFor: '*ma-core' stamp: 'cmm 7/15/2006 15:12'!
maIsSortedCollection
	^ false! !

!Object methodsFor: '*ma-core' stamp: 'cmm 11/10/2005 22:07'!
maMarked: aString
	"This is a marker method used to indicate that we wish to come back and re-examine
	code in the future for possible improvement.  For now, try to keep improvements categorized
	via anEsAtom that we can Browse References to, if necessary.  The possibilities should be:

		'ugly'
		'performance'
		'bug'
		'dev'
		'vmSpecific'
		'releaseSpecific'
		'otherPackageSupport'
		'system override'
		'deprecated'
		'magic'
		'debug'
	A *comment* then should follow to provide more detail."

	aString = 'delete' ifTrue: [ self halt: 'Oops..  looks like you still need this method.' ]! !

!Object methodsFor: '*ma-core' stamp: 'cmm 2/7/2008 16:56'!
maOriginalClass
	"Unfortunately, we don't have complete class-transparency with WriteBarrier.  #species isn't always the quite the thing needed.  In rare cases (browse my senders), my actual class is needed."
	^ self class! !

!Object methodsFor: '*ma-core' stamp: 'cm 12/29/2001 01:14'!
maPrintAbbreviatedOn: aStream
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"
! !

!Object methodsFor: '*ma-core' stamp: 'cmm 7/10/2013 13:55'!
maPrintAttribute: aString on: aStream 
	aString isSymbol
		ifTrue:
			[ self
				maPrintSelector: aString
				on: aStream ]
		ifFalse:
			[ self
				maPrintInstVar: aString
				on: aStream ]! !

!Object methodsFor: '*ma-core' stamp: ''!
maPrintAttributes: arrayOfSymbols on: aStream

	arrayOfSymbols do:
		[ :each |
		self
			maPrintAttribute: each
			on: aStream ]
! !

!Object methodsFor: '*ma-core' stamp: 'cmm 1/31/2013 15:32'!
maPrintDescription
	^ self printString! !

!Object methodsFor: '*ma-core' stamp: 'cmm 12/19/2002 23:26'!
maPrintInstVar: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' = '.
	value := self instVarNamed: aSymbol asString.
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]
! !

!Object methodsFor: '*ma-core' stamp: 'cmm 7/30/2007 00:23'!
maPrintOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*ma-core' stamp: 'cmm 7/10/2013 13:57'!
maPrintSelector: aSymbol on: aStream 
	| value |
	aStream
		 cr ;
		 tab ;
		 nextPutAll: aSymbol ;
		 nextPutAll: ' : '.
	value := [ self perform: aSymbol ]
		on: Error
		do: [ : exc | exc return: (exc messageText ifNil: [ 'error' ]) ].
	aStream maPrint: value! !

!Object methodsFor: '*ma-core' stamp: 'cmm 7/24/2002 20:46'!
maShallowCopy

	^self shallowCopy! !

!Object methodsFor: '*ma-core' stamp: 'cmm 6/17/2010 15:28'!
maSuggestedFilename
	"Answer a name that would be suitable, if the receiver were to be saved in a file."
	^ self name asFileName ! !

!Object methodsFor: '*ma-core' stamp: 'cmm 7/9/2008 20:39'!
realObject
	"Balance API with MagmaForwardingProxy, so applications may sometimes choose to get hold of the actual object, not just a forwardingProxy."
	^ self! !

!Exception class methodsFor: '*ma-core' stamp: 'cmm 9/18/2005 23:56'!
messageText: aString

	^ self new
		messageText: aString ;
		yourself! !

!Exception methodsFor: '*ma-core' stamp: 'cmm 9/28/2008 18:18'!
isMaUserError

	^false! !

!Exception methodsFor: '*ma-core' stamp: 'cmm 8/11/2002 23:35'!
maIsException

	^true! !

Exception subclass: #MaRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Requests'!

MaRequest subclass: #MaStringRequest
	instanceVariableNames: 'initialAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Requests'!

!MaStringRequest commentStamp: 'cmm 10/9/2005 12:01' prior: 0!
Some applications need to prompt the user for a String at an inopportune time; for example some operations may require the users privateKey file and we want to do this on a JIT basis.

The purpose of this class is to provide a default way to ask the user for a String while allowing programs to override with their own approach.!

MaStringRequest subclass: #MaFileRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Core-Requests'!

!MaFileRequest class methodsFor: 'create' stamp: 'cmm 11/16/2005 22:11'!
message: aString filename: filenameString initialDirectory: aFileDirectory

	^ self new
		messageText: aString, '.  Where is ', filenameString, '?' ;
		initialAnswer: aFileDirectory fullName ;
		yourself! !

!MaStringRequest class methodsFor: 'create' stamp: 'cmm 9/27/2005 00:49'!
messageText: messageString initialAnswer: initialAnswerString

	^ (self messageText: messageString) 
		initialAnswer: initialAnswerString ;
		yourself! !

!MaStringRequest methodsFor: 'initialize-release' stamp: 'cmm 12/7/2011 21:49'!
defaultAction
	self resume:
		(UIManager default 
			request: self messageText
			initialAnswer: self initialAnswer)! !

!MaStringRequest methodsFor: 'accessing' stamp: 'cmm 3/1/2012 21:30'!
initialAnswer
	^ initialAnswer ifNil: [ String empty ]! !

!MaStringRequest methodsFor: 'initialize-release' stamp: 'cmm 9/27/2005 00:49'!
initialAnswer: aString
	initialAnswer := aString! !

!Interval methodsFor: '*ma-core' stamp: 'cmm 6/4/2005 17:22'!
maEnvelopes: anInterval 
	"Return true if anInterval fits entirely inside the receiver."

	^ (anInterval first between: start and: stop)
	and: [ anInterval last between: start and: stop ]! !

!Interval methodsFor: '*ma-core' stamp: 'cmm 6/4/2005 01:09'!
maIntersects: anInterval 
	"Return true if the receiver overlaps with anInterval."

	^(start between: anInterval first and: anInterval last) 
		or: [ anInterval first between: start and: stop ]! !

!Interval methodsFor: '*ma-core' stamp: 'cmm 4/26/2013 14:23'!
printRangeFor: aNumber withMarkAt: marker on: aStream 
	"The range of performance of this trade, with the final close enclosed in vertical bars.  The + sign marks the break-even point."
	(aNumber isNaN or: [ aNumber isInfinite ])
		ifTrue: [ aStream maPrint: 'n/a' ]
		ifFalse:
			[ | priorN markerChar decimalPlaces |
			markerChar := $+.
			decimalPlaces := ((step log: 10) roundTo: 1) abs.
			start > marker ifTrue: [ aStream maPrint: markerChar ].
			start = aNumber ifFalse: [ aStream maPrint: (start printShowingDecimalPlaces: decimalPlaces) ].
			priorN := start.
			self do:
				[ : n | aStream nextPut:
					((marker
						between: priorN
						and: n)
						ifTrue: [ markerChar ]
						ifFalse: [ $- ]).
				(aNumber
					between: priorN
					and: n) ifTrue: [ aStream maPrint: (aNumber printShowingDecimalPlaces: decimalPlaces) ].
				priorN := n ].
			aStream maPrint: (stop printShowingDecimalPlaces: decimalPlaces).
			stop < marker ifTrue: [ aStream maPrint: markerChar ] ]! !
MaCoreConstants initialize!
MaCommandLineProcessor initialize!
MaSingleton initialize!
